/*
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

define([
    "dojo/_base/declare",
    "dojox/mvc/at",
    "./base/Status",
    "aps/Tile"
], function(declare, at, Status, Tile) {

    return declare(Tile, {
        status: null,
        statusInfo: null,

        _setStatusAttr: function(val){
            var self = this;
            if (self.status != val || (self.get("info") === null && val !== null)) {
                self.status = val;

                if (val == null) {
                    self.set("info", null);
                    return;
                }

                var status = new Status({
                    useIcon: false,
                    gridSize: 'md-12',
                    status: val,
                    statusInfo: self.statusInfo
                });
                self.set("info", status);
            }
        }
    });
});

