<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
interface Model_MinimalCommitmentDiscountManagerInterface
{
    /**
     * @param int $discountId
     * @return Service_PbaApi_Api_Response_Struct_Discount|null
     */
    public function fetchDiscountById($discountId);

    /**
     * @param int $accountId
     * @return Service_OpenApi_Response_AccountInfo
     * @throws \Rest\RestException
     */
    public function fetchFirstLevelResellerAccountById($accountId);

    /**
     * @param Service_PbaApi_Api_Response_Struct_DiscountInterface $discount
     * @return bool
     */
    public function detectAllowingDiscountForFirstLevelReseller(
        Service_PbaApi_Api_Response_Struct_DiscountInterface $discount
    );

    /**
     * @return Service_OpenApi_Response_AccountInfo[]
     */
    public function fetchFirstLevelResellersAccounts();
}
