<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

interface Model_OSA_SubscriptionParametersManagerInterface
{
    const PARAMETER_EXCLUDE_FROM_REPORT = 'ExcludeFromReport';
    const PARAMETER_DISCOUNT = 'Discount';
    const PARAMETER_DATACENTER = 'Datacenter';
    const PARAMETER_STORAGE = 'Storage';
    const PARAMETER_IS_EXTERNAL_GROUP = 'IsExternalGroup';
    const PARAMETER_GROUP_ID = 'GroupId';
    const PARAMETER_WS_DISCOUNT = 'WS_Discount';
    const PARAMETER_PASSWORD = 'Password';

    const EXCLUDE_FROM_REPORT_OFF = 0;
    const EXCLUDE_FROM_REPORT_ON = 1;

    /**
     * @param int $subscriptionId
     * @return int
     * @throws Exception
     */
    public function getParameterDatacenterId($subscriptionId);

    /**
     * @param int $subscriptionId
     * @return string
     * @throws Exception
     */
    public function getParameterStorageId($subscriptionId);

    /**
     * @param int $subscriptionId
     * @return int
     * @throws Exception
     */
    public function getParameterIsExternal($subscriptionId);

    /**
     * @param int $subscriptionId
     * @return int
     * @throws Exception
     */
    public function getParameterGroupId($subscriptionId);

    /**
     * @param int $subscriptionId
     * @return bool
     * @throws Exception
     */
    public function getParameterWSDiscount($subscriptionId);

    /**
     * @param $subscriptionId
     * @param integer $value
     * @throws Service_PbaApi_Api_Exception
     */
    public function setParameterExcludedFromReport($subscriptionId, $value);

    /**
     * @param $subscriptionId
     * @return int
     * @throws Service_PbaApi_Api_Exception
     */
    public function getParameterExcludedFromReport($subscriptionId);

    /**
     * @param $subscriptionId
     * @return int
     * @throws Service_PbaApi_Api_Exception
     */
    public function getParameterDiscount($subscriptionId);

    /**
     * @param int $subscriptionId
     * @return string
     * @throws Exception
     */
    public function getParameterPassword($subscriptionId);

    /**
     * @param $subscriptionId
     * @param int $value
     */
    public function setParameterPassword($subscriptionId, $value);
}
