<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

class Service_AmsApiClient_Response_Struct_Login
{
    private $services;

    const PROPERTY_SERVICE_TYPE = 'type';
    const PROPERTY_SERVICE_URL = 'url';
    const SERVICE_TYPE_BACKUP = 'backup';

    public function getBackupUrl()
    {
        $backupService = reset(array_filter($this->services, function ($service) {
            return $service[static::PROPERTY_SERVICE_TYPE] == static::SERVICE_TYPE_BACKUP;
        })) ?: null;

        if ($backupService) {
            return Arr::get($backupService, static::PROPERTY_SERVICE_URL);
        }

        return null;
    }

    /**
     * @return mixed
     */
    public function getServices()
    {
        return $this->services;
    }

    /**
     * @param mixed $services
     */
    public function setServices($services)
    {
        $this->services = $services;
    }

}