<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

abstract class Service_BaseClient_ApiAbstract
{
    /** @var  Service_BaseClient_IRestClient */
    protected $_restClient;

    /**
     * @param Service_BaseClient_IRestClient $restClient
     */
    public function __construct(Service_BaseClient_IRestClient $restClient = NULL)
    {
        $this->_restClient = is_null($restClient) ? new Service_BaseClient_RestClient() : $restClient;
    }

    /**
     * @return Service_BaseClient_RestClient
     */
    public function getRestClient()
    {
        return $this->_restClient;
    }

    /**
     * @param Service_BaseClient_Request_IRequest $request
     * @param string $authHeaders
     * @return mixed
     */
    protected function _call(Service_BaseClient_Request_IRequest $request, $authHeaders = NULL)
    {
        $response = $this->_restClient->execute($request, $authHeaders);
        return $response->getData();
    }
}
