<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

interface Service_BaseClient_IRestTransport
{
    /**
     * @param string $cookieFile
     */
    public function setCookieFile($cookieFile);

    /**
     * @return bool
     */
    public function hasCookieFile();

    public function invalidateCookies();

    public function refresh();

    /**
     * @param Service_BaseClient_TransportStrategy_ITransportStrategy $sendingStrategy
     */
    public function setSendingStrategy(Service_BaseClient_TransportStrategy_ITransportStrategy $sendingStrategy);

    /**
     * @return Service_BaseClient_TransportStrategy_ITransportStrategy
     */
    public function getSendingStrategy();

    /**
     * @param string $uri
     * @param string $method
     * @param string $requestBody
     * @param string $authHeaders
     * @return array(code, responseBody)
     */
    public function execute($uri, $method, $requestBody, $authHeaders = NULL);
}
