<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_CreateNewAdministrator extends Service_BaseClient_Request_Json
{
    const REQUEST_URL_FORMAT = '/groups/%d/admins/';

    /**
     * @param Service_BaseClient_Request_Struct_IArrayRepresentation $requestObject
     * @param int $groupId
     */
    public function __construct(Service_BaseClient_Request_Struct_IArrayRepresentation $requestObject, $groupId)
    {
        $this->_requestObject = $requestObject;
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, $groupId);
        $this->_method = self::METHOD_POST;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_CreateNewUser
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_CreateNewAdministrator($responseBody);
    }
}