<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_GetGroupById extends Service_BaseClient_Request_Base
{
    const REQUEST_URL_FORMAT = '/groups/%s';
    const EXCEPTION_GROUP_IS_NOT_FOUND = 'EUC is not found.';
    const HTTP_CODE_EUC_IS_NOT_FOUND = 404;

    /** @var int|string */
    private $_groupId;

    /**
     * @param int|string $groupId
     */
    public function __construct($groupId)
    {
        $this->_groupId = $groupId;
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, $groupId);
        $this->_method = self::METHOD_GET;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_GetGroupById
     * @throws Exception
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        if ($httpCode === self::HTTP_CODE_EUC_IS_NOT_FOUND)
        {
            throw new Exception(self::EXCEPTION_GROUP_IS_NOT_FOUND);
        }
        return empty($this->_groupId)
            ? new Service_MspApiClient_Response_Empty($responseBody)
            : new Service_MspApiClient_Response_GetGroupById($responseBody);
    }
}
