<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_MspApiClient_Request_GetUsageReport extends Service_BaseClient_Request_Json
{
    const REQUEST_URL_FORMAT = '/groups/%s/reports/ordered?%s';

    /**
     * @param Service_MspApiClient_Request_Struct_UsageReport $requestObject
     * @param int $groupId
     */
    public function __construct(Service_MspApiClient_Request_Struct_UsageReport $requestObject, $groupId)
    {
        $this->_resource = Str::format(
            self::REQUEST_URL_FORMAT,
            $groupId,
            http_build_query($requestObject->toArray())
        );
        $this->_method = self::METHOD_GET;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_Empty|Service_MspApiClient_Response_GetUsageReport
     */
    public function getExpectedResponse($httpCode = null, $responseBody = null)
    {
        switch ($httpCode) {
            case 202:
                return new Service_MspApiClient_Response_Empty($responseBody);
            default:
                return new Service_MspApiClient_Response_GetUsageReport($responseBody);
        }
    }
}