<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_MailActivate extends Service_BaseClient_Request_Base
{
    const REQUEST_URL_FORMAT = '/actions/mail/activate?login=%s';

    /**
     * @param string $login
     */
    public function __construct($login)
    {
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, $login);
        $this->_method = self::METHOD_GET;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_MailActivate
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_MailActivate($responseBody);
    }
}