<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_MspApiClient_Request_RequestUsageReport extends Service_BaseClient_Request_Json
{
    const REQUEST_URL_FORMAT = '/groups/%s/reports/ordered';

    /**
     * @param Service_MspApiClient_Request_Struct_RequestUsageReport $requestObject
     * @param int $groupId
     */
    public function __construct(Service_MspApiClient_Request_Struct_RequestUsageReport $requestObject, $groupId)
    {
        $this->_resource = Str::format(self::REQUEST_URL_FORMAT, $groupId);
        $this->_requestObject = $requestObject;
        $this->_method = self::METHOD_POST;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_Empty
     */
    public function getExpectedResponse($httpCode = null, $responseBody = null)
    {
        return new Service_MspApiClient_Response_RequestUsageReport($responseBody);
    }
}
