<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_ResetSend extends Service_BaseClient_Request_Json
{
    const REQUEST_URL_FORMAT = '/actions/reset/?token=%s';

    /**
     * @param string $token
     * @param string $password
     */
    public function __construct($token, $password)
    {
        $accountActivate = new Service_MspApiClient_Request_Struct_AccountsActivate();
        $accountActivate->setPassword($password);
        $this->_requestObject = $accountActivate;
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, $token);
        $this->_method = self::METHOD_POST;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_Accounts
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_Accounts($responseBody);
    }
}