<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_Struct_AdministratorInfo extends Service_BaseClient_Request_Struct_Updatable
{
    const FIELD_TYPE = 'access_type';
    const FIELD_EMAIL = 'email';
    const FIELD_FIRSTNAME = 'firstname';
    const FIELD_LASTNAME = 'lastname';
    const FIELD_LOGIN = 'login';
    const FIELD_NOTIFICATIONS_BACKUP = 'notifications_backup';
    const FIELD_NOTIFICATIONS_MANAGEMENT = 'notifications_management';

    /** @var string */
    private $_type;
    /** @var string */
    private $_email;
    /** @var string */
    private $_firstName;
    /** @var string */
    private $_lastName;
    /** @var string */
    private $_login;    
    /** @var Enum_NotificationsBackup */
    private $_notificationsBackup;
    /** @var int */
    private $_notificationsManagement;

    /**
     * @return array
     */
    public function toArray()
    {
        return array(
            self::FIELD_TYPE => $this->getType(),
            self::FIELD_EMAIL => $this->getEmail(),
            self::FIELD_FIRSTNAME => $this->getFirstName(),
            self::FIELD_LASTNAME => $this->getLastName(),
            self::FIELD_LOGIN => $this->getLogin(),
            self::FIELD_NOTIFICATIONS_BACKUP => $this->getNotificationsBackup(),
            self::FIELD_NOTIFICATIONS_MANAGEMENT => $this->getNotificationsManagement(),
        );
    }
    
    /**
     * @param string $type
     */
    public function setType($type)
    {
        $this->_markFieldAsUpdated(self::FIELD_TYPE);
        $this->_type = $type;
    }

    /**
     * @return string
     */
    public function getType()
    {
        return $this->_type;
    }    

    /**
     * @param string $email
     */
    public function setEmail($email)
    {
        $this->_markFieldAsUpdated(self::FIELD_EMAIL);
        $this->_email = $email;
    }

    /**
     * @return string
     */
    public function getEmail()
    {
        return $this->_email;
    }

    /**
     * @param string $firstName
     */
    public function setFirstName($firstName)
    {
        $this->_markFieldAsUpdated(self::FIELD_FIRSTNAME);
        $this->_firstName = $firstName;
    }

    /**
     * @return string
     */
    public function getFirstName()
    {
        return $this->_firstName;
    }

    /**
     * @param string $lastName
     */
    public function setLastName($lastName)
    {
        $this->_markFieldAsUpdated(self::FIELD_LASTNAME);
        $this->_lastName = $lastName;
    }

    /**
     * @return string
     */
    public function getLastName()
    {
        return $this->_lastName;
    }
    
    /**
     * @param string $login
     */
    public function setLogin($login)
    {
        $this->_markFieldAsUpdated(self::FIELD_LOGIN);
        $this->_login = $login;
    }

    /**
     * @return string
     */
    public function getLogin()
    {
        return $this->_login;
    }    

    /**
     * @param Enum_NotificationsBackup $notificationsBackup
     */
    public function setNotificationsBackup(Enum_NotificationsBackup $notificationsBackup)
    {
        $this->_markFieldAsUpdated(self::FIELD_NOTIFICATIONS_BACKUP);
        $this->_notificationsBackup = $notificationsBackup;
    }

    /**
     * @return Enum_NotificationsBackup
     */
    public function getNotificationsBackup()
    {
        return is_null($this->_notificationsBackup) ? NULL : $this->_notificationsBackup->getValue();
    }

    /**
     * @param int $notificationsManagement
     */
    public function setNotificationsManagement($notificationsManagement)
    {
        $this->_markFieldAsUpdated(self::FIELD_NOTIFICATIONS_MANAGEMENT);
        $this->_notificationsManagement = $notificationsManagement;
    }

    /**
     * @return int
     */
    public function getNotificationsManagement()
    {
        return $this->_notificationsManagement;
    }
}
