<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_MspApiClient_Request_Struct_UserPrivileges extends Service_BaseClient_Request_Struct_Updatable
{
    const USER_UNLIMITED_VALUE = -1;

    const FIELD_QUOTA_STORAGE_HARD = "quota_storage_hard";
    const FIELD_QUOTA_LOCAL_STORAGE_HARD = "quota_local_storage_hard";
    const FIELD_QUOTA_SERVERS_HARD = "quota_servers_hard";
    const FIELD_QUOTA_VMS_HARD = "quota_vms_hard";
    const FIELD_QUOTA_WORKSTATIONS_HARD = "quota_workstations_hard";
    const FIELD_QUOTA_MOBILES_HARD = "quota_mobiles_hard";
    const FIELD_QUOTA_MAILBOX_HARD = "quota_mailboxes_hard";
    const FIELD_QUOTA_WEBSITES_HARD = "quota_websites_hard";

    const FIELD_STORAGE_SIZE = "storage_size";
    const FIELD_LOCAL_STORAGE_SIZE = "local_storage_size";
    const FIELD_SERVER_COUNT = "server_count";
    const FIELD_VM_COUNT = "vm_count";
    const FIELD_WORKSTATION_COUNT = "workstation_count";
    const FIELD_MOBILE_COUNT = "mobile_count";
    const FIELD_MAILBOX_COUNT = "mailbox_count";
    const FIELD_WEBSITE_COUNT = 'website_count';

    /** @var  int */
    private $serverCount;
    /** @var  int */
    private $storageSize;
    /** @var  int */
    private $localStorageSize;
    /** @var  int */
    private $vmCount;
    /** @var  int */
    private $workstationCount;
    /** @var  int */
    private $mobileCount;
    /** @var  int */
    private $mailboxCount;
    /** @var  int */
    private $websiteCount;

    /**
     * @return array
     */
    public function toArray()
    {
        //TODO - separate hard/soft quotas
        $result = array();

        $count = $this->getStorageSize();
        if (!is_null($count)) {
            $result[self::FIELD_STORAGE_SIZE] = $count;
            $result[self::FIELD_QUOTA_STORAGE_HARD] = $count;
        }

        $count = $this->getLocalStorageSize();
        if (!is_null($count)) {
            $result[self::FIELD_LOCAL_STORAGE_SIZE] = $count;
            $result[self::FIELD_QUOTA_LOCAL_STORAGE_HARD] = $count;
        }

        $count = $this->getServerCount();
        if (!is_null($count)) {
            $result[self::FIELD_SERVER_COUNT] = $count;
            $result[self::FIELD_QUOTA_SERVERS_HARD] = $count;
        }

        $count = $this->getVmCount();
        if (!is_null($count)) {
            $result[self::FIELD_VM_COUNT] = $count;
            $result[self::FIELD_QUOTA_VMS_HARD] = $count;
        }

        $count = $this->getWorkstationCount();
        if (!is_null($count)) {
            $result[self::FIELD_WORKSTATION_COUNT] = $count;
            $result[self::FIELD_QUOTA_WORKSTATIONS_HARD] = $count;
        }

        $count = $this->getMobileCount();
        if (!is_null($count)) {
            $result[self::FIELD_MOBILE_COUNT] = $count;
            $result[self::FIELD_QUOTA_MOBILES_HARD] = $count;
        }

        $count = $this->getMailboxCount();
        if (!is_null($count)) {
            $result[self::FIELD_MAILBOX_COUNT] = $count;
            $result[self::FIELD_QUOTA_MAILBOX_HARD] = $count;
        }

        $count = $this->getWebsiteCount();
        if (!is_null($count)) {
            $result[self::FIELD_WEBSITE_COUNT] = $count;
            $result[self::FIELD_QUOTA_WEBSITES_HARD] = $count;
        }

        return $result;
    }

    /**
     * @param int $serverCount
     */
    public function setServerCount($serverCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_QUOTA_SERVERS_HARD);
        $this->serverCount = $serverCount;
    }

    /**
     * @return int
     */
    public function getServerCount()
    {
        return $this->serverCount;
    }

    /**
     * @param int $storageSize
     */
    public function setStorageSize($storageSize)
    {
        $this->_markFieldAsUpdated(self::FIELD_QUOTA_STORAGE_HARD);
        $this->storageSize = $storageSize;
    }

    /**
     * @return int
     */
    public function getStorageSize()
    {
        return $this->storageSize;
    }

    /**
     * @return int
     */
    public function getLocalStorageSize()
    {
        return $this->localStorageSize;
    }

    /**
     * @param int $localStorageSize
     */
    public function setLocalStorageSize($localStorageSize)
    {
        $this->_markFieldAsUpdated(self::FIELD_QUOTA_LOCAL_STORAGE_HARD);
        $this->localStorageSize = $localStorageSize;
    }

    /**
     * @param int $vmCount
     */
    public function setVmCount($vmCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_QUOTA_VMS_HARD);
        $this->vmCount = $vmCount;
    }

    /**
     * @return int
     */
    public function getVmCount()
    {
        return $this->vmCount;
    }

    /**
     * @param int $workstationCount
     */
    public function setWorkstationCount($workstationCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_QUOTA_WORKSTATIONS_HARD);
        $this->workstationCount = $workstationCount;
    }

    /**
     * @return int
     */
    public function getWorkstationCount()
    {
        return $this->workstationCount;
    }

    /**
     * @return int
     */
    public function getMobileCount()
    {
        return $this->mobileCount;
    }

    /**
     * @param int $mobileCount
     */
    public function setMobileCount($mobileCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_QUOTA_MOBILES_HARD);
        $this->mobileCount = $mobileCount;
    }

    /**
     * @return int
     */
    public function getMailboxCount()
    {
        return $this->mailboxCount;
    }

    /**
     * @param int $mailboxCount
     */
    public function setMailboxCount($mailboxCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_QUOTA_MAILBOX_HARD);
        $this->mailboxCount = $mailboxCount;
    }

    /**
     * @return int
     */
    public function getWebsiteCount()
    {
        return $this->websiteCount;
    }

    /**
     * @param int $websiteCount
     */
    public function setWebsiteCount($websiteCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_QUOTA_WEBSITES_HARD);
        $this->websiteCount = $websiteCount;
    }
}