<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Response_Search extends Service_BaseClient_Response_Base
{
    const PROPERTY_ITEMS = 'items';
    const PROPERTY_ID = 'id';
    const PROPERTY_NAME = 'name';
    const PROPERTY_PARENT_ID = 'parent_id';
    const PROPERTY_KIND = 'kind';

    /**
     * @param array $responseData
     * @return Service_MspApiClient_Response_Struct_SearchItem[]
     */
    protected function _init(array $responseData)
    {
        $searchItems = array();
        foreach ($responseData[self::PROPERTY_ITEMS] as $param)
        {
            $searchItem = new Service_MspApiClient_Response_Struct_SearchItem();
            $searchItem->setId($param[self::PROPERTY_ID]);
            $searchItem->setName($param[self::PROPERTY_NAME]);
            $searchItem->setParentId($param[self::PROPERTY_PARENT_ID]);
            $searchItem->setKind($param[self::PROPERTY_KIND]);
            $searchItems[] = $searchItem;
        }
        return $searchItems;
    }

} 