<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Response_Struct_GroupInfo
{
    /** @var int */
    private $_id;
    /** @var string */
    private $_name;
    /** @var string */
    private $_customerId;
    /** @var Service_MspApiClient_Response_Struct_GroupContact */
    private $_contact;
    /** @var Service_MspApiClient_Request_Struct_UserPrivileges */
    private $_privileges;
    /** @var Service_MspApiClient_Response_Struct_UserUsage */
    private $_usage;
    /** @var int */
    private $_version;
    /** @var int */
    private $_status;
    /** @var int */
    private $_kind;
    /** @var int */
    private $_parentId;
    /** @var string */
    private $_internalTag;

    public function __construct()
    {
        $this->_privileges = new Service_MspApiClient_Response_Struct_UserPrivileges();
        $this->_usage = new Service_MspApiClient_Response_Struct_UserUsage();
        $this->_contact = new Service_MspApiClient_Response_Struct_GroupContact();
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->_id = $id;
    }

    /**
     * @return int
     */
    public function getId()
    {
        return $this->_id;
    }

    /**
     * @param string $name
     */
    public function setName($name)
    {
        $this->_name = $name;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->_name;
    }

    /**
     * @param string $customerId
     */
    public function setCustomerId($customerId)
    {
        $this->_customerId = $customerId;
    }

    /**
     * @return string
     */
    public function getCustomerId()
    {
        return $this->_customerId;
    }

    /**
     * @return Service_MspApiClient_Request_Struct_UserPrivileges
     */
    public function getPrivileges()
    {
        return $this->_privileges;
    }

    /**
     * @return Service_MspApiClient_Response_Struct_UserUsage
     */
    public function getUsage()
    {
        return $this->_usage;
    }

    /**
     * @return Service_MspApiClient_Response_Struct_GroupContact
     */
    public function getContact()
    {
        return $this->_contact;
    }

    /**
     * @param int $version
     */
    public function setVersion($version)
    {
        $this->_version = $version;
    }

    /**
     * @return int
     */
    public function getVersion()
    {
        return $this->_version;
    }

    /**
     * @param int $status
     */
    public function setStatus($status)
    {
        $this->_status = $status;
    }

    /**
     * @return int
     */
    public function getStatus()
    {
        return $this->_status;
    }

    /**
     * @param int $kind
     */
    public function setKind($kind)
    {
        $this->_kind = $kind;
    }

    /**
     * @return int
     */
    public function getKind()
    {
        return $this->_kind;
    }

    /**
     * @param int $parentId
     */
    public function setParentId($parentId)
    {
        $this->_parentId = $parentId;
    }

    /**
     * @return int
     */
    public function getParentId()
    {
        return $this->_parentId;
    }

    /**
     * @return string
     */
    public function getInternalTag()
    {
        return $this->_internalTag;
    }

    /**
     * @param string $internalTag
     */
    public function setInternalTag($internalTag)
    {
        $this->_internalTag = $internalTag;
    }
}
