<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_OpenApi_Validator_InvalidStatus extends Service_OpenApi_Validator_Base
{
    const ERROR_CODE = 'error_code';
    const ERROR_MESSAGE = 'error_message';
    const STATUS = 'status';
    const DEFAULT_ERROR_CODE = 0;

    /**
     * @param mixed $xmlRpcDecodedResponse
     * @param Service_OpenApi_Response_RawInterface $response
     * @throws Service_OpenApi_Validator_BaseException
     * @return bool
     */
    public function handleResponse($xmlRpcDecodedResponse, Service_OpenApi_Response_RawInterface $response = NULL)
    {
        $errorMessage = isset($xmlRpcDecodedResponse[self::ERROR_MESSAGE]) ?
            $xmlRpcDecodedResponse[self::ERROR_MESSAGE] : '';

        if ($xmlRpcDecodedResponse[self::STATUS] || $errorMessage)
        {
            $code = isset($xmlRpcDecodedResponse[self::ERROR_CODE]) ? $xmlRpcDecodedResponse[self::ERROR_CODE] : self::DEFAULT_ERROR_CODE;
            throw new Service_OpenApi_Validator_InvalidStatusException(
                $errorMessage,
                $code
            );
        }
        return parent::handleResponse($xmlRpcDecodedResponse);
    }
} 
