<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_OpenApi_Validator_XmlFailure extends Service_OpenApi_Validator_Base
{
    const XML_RPC_IS_FAULT = 'XML RPC is fault';

    /** @var  Service_OpenApi_XmlRpc */
    private $_xmlRpc;

    function __construct(
        Service_OpenApi_Validator_ItemInterface $successorHandler = NULL,
        Service_OpenApi_XmlRpc $xmlRpc = NULL
    )
    {
        $this->_xmlRpc = is_null($xmlRpc) ? new Service_OpenApi_XmlRpc() : $xmlRpc;
        parent::__construct($successorHandler);
    }

    /**
     * @param mixed $xmlRpcDecodedResponse
     * @param Service_OpenApi_Response_RawInterface $response
     * @throws Service_OpenApi_Validator_BaseException
     * @return bool
     */
    public function handleResponse($xmlRpcDecodedResponse, Service_OpenApi_Response_RawInterface $response = NULL)
    {
        if (is_array($xmlRpcDecodedResponse) && $this->_xmlRpc->isFault($xmlRpcDecodedResponse))
        {
            throw new Service_OpenApi_Validator_BaseException(self::XML_RPC_IS_FAULT);
        }
        return parent::handleResponse($xmlRpcDecodedResponse);
    }
} 
