<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Request_Struct_TaxDetailAttributes
{
    /**
     * ID of a tax that exists in Business Automation;
     * @var string
     */
    private $taxId;

    /**
     * amount of the order that is subject for this tax;
     * @var float
     */
    private $txblAmount;

    /**
     * tax amount applied to the order.
     * @var float
     */
    private $taxAmount;

    /**
     * @return string
     */
    public function getTaxId()
    {
        return $this->taxId;
    }

    /**
     * @param string $taxId
     */
    public function setTaxId($taxId)
    {
        $this->taxId = $taxId;
    }

    /**
     * @return float
     */
    public function getTxblAmount()
    {
        return $this->txblAmount;
    }

    /**
     * @param float $txblAmount
     */
    public function setTxblAmount($txblAmount)
    {
        $this->txblAmount = $txblAmount;
    }

    /**
     * @return float
     */
    public function getTaxAmount()
    {
        return $this->taxAmount;
    }

    /**
     * @param float $taxAmount
     */
    public function setTaxAmount($taxAmount)
    {
        $this->taxAmount = $taxAmount;
    }

    public function __toString()
    {
        $attributes = array(
            'TaxID' => $this->taxId,
            'TxblAmt' => $this->txblAmount,
            'TaxAmt' => $this->taxAmount,
        );

        $result = 'TaxDet:';
        foreach ($attributes as $k => $v) {
            if (is_null($v)) {
                continue;
            }
            $result .= $k . '=' . $v . ';';
        }
        return $result;
    }
}
