<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetAndValidatePlanParams extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $responseData = $this->_getProperty(0, $responseArray);

        $parameters = array();
        foreach ($responseData as $parameterData) {
            $parameters[] = $this->initParameter($parameterData);
        }

        return $parameters;
    }

    private function initParameter($data)
    {
        $parameter = new Service_PbaApi_Api_Response_Struct_GetAndValidatePlanParams();
        $parameter->setParameterId($data[0]);
        $parameter->setParameterType($data[1]);
        $parameter->setParameterName($data[2]);
        $parameter->setDescription($data[3]);
        $parameter->setDefaultValue($data[4]);
        $parameter->setRequired($data[5]);
        $parameter->setStatus($data[6]);
        $parameter->setMessage($data[7]);
        $parameter->setServiceTemplateParameterWeight($data[8]);
        return $parameter;
    }
}
