<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetDiscountById extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $respondDiscountData = $this->_getProperty(0, $responseArray);
        $discount = new Service_PbaApi_Api_Response_Struct_Discount();
        $discount->setId($this->_getProperty(0, $respondDiscountData));
        $discount->setName($this->_getProperty(1, $respondDiscountData));
        $discount->setOwnerAccountId($this->_getProperty(2, $respondDiscountData));
        $discount->setType($this->_getProperty(3, $respondDiscountData));
        $discount->setStatus($this->_getProperty(4, $respondDiscountData));
        $discount->setRate((double)$this->_getProperty(7, $respondDiscountData));
        $discount->setIsForAllPlans((bool)$this->_getProperty(8, $respondDiscountData));
        $discount->setIsForAllResources((bool)$this->_getProperty(9, $respondDiscountData));
        return $discount;
    }
}
