<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetPlan extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result for operation GetPlan';

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_Struct_PlanInterface
     * @throws Service_PbaApi_Client_InvalidPropertyException
     */
    protected function _init(array $responseArray = NULL)
    {
        if (is_null($responseArray))
        {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        /**
         * Available fields:
         *   PlanID,
         *   name,
         *   serviceTemplateID,
         *   planCategoryID,
         *   ServTermID,
         *   shortDescription,
         *   longDescription,
         *   GroupID,
         *   published,
         *   attachUsageStatistics,
         *   AccountID,
         *   NotificationTmpl,
         *   CustomerClassClassID,
         *   RecurringType,
         *   BillingPeriodType,
         *   BillingPeriod,
         *   BillingPeriodDescription,
         *   PricePeriodType,
         *   AutoRenewDescription,
         *   AutoRenew_PlanPeriodID,
         *   ShowPriority,
         *   Default_PlanPeriodID,
         *   NotifScheduleScheduleID,
         *   vIsOTFPlan,
         *   vHImage,
         *   vShowHideAdvanced,
         *   vUiManagedState.
         */
        $planData = $this->_getProperty(0, $responseArray);

        $plan = new Service_PbaApi_Api_Response_Struct_Plan();
        $plan->setPlanId($this->_getProperty(0, $planData));
        $plan->setName($this->_getProperty(1, $planData));
        $plan->setServiceTemplateId($this->_getProperty(2, $planData));

        return $plan;
    }
}
