<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetPlanPeriodList extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $response = $this->_getProperty(0, $responseArray);

        $planPeriodList = array();
        foreach ($response as $responseItem) {
            $planPeriod = new Service_PbaApi_Api_Response_Struct_PlanPeriodListItem();
            $planPeriod->setPlanPeriodID($this->_getProperty(0, $responseItem));
            $planPeriod->setPeriod($this->_getProperty(1, $responseItem));
            $planPeriod->setPeriodType($this->_getProperty(2, $responseItem));
            $planPeriod->setTrial($this->_getProperty(3, $responseItem));
            $planPeriod->setSetupFee($this->_getProperty(4, $responseItem));
            $planPeriod->setSubscriptionFee($this->_getProperty(5, $responseItem));
            $planPeriod->setRenewalFee($this->_getProperty(6, $responseItem));
            $planPeriod->setTransferFee($this->_getProperty(7, $responseItem));
            $planPeriod->setNonRefundableAmount($this->_getProperty(8, $responseItem));
            $planPeriod->setRefundPeriod($this->_getProperty(9, $responseItem));
            $planPeriod->setEnabled($this->_getProperty(10, $responseItem));
            $planPeriod->setNumberOfPeriods($this->_getProperty(11, $responseItem));
            $planPeriod->setFeeText($this->_getProperty(12, $responseItem));
            $planPeriod->setSortNumber($this->_getProperty(13, $responseItem));
            $planPeriod->setIsOTFI($this->_getProperty(14, $responseItem));
            $planPeriod->setDepositFee($this->_getProperty(15, $responseItem));
            $planPeriod->setDepositDescr($this->_getProperty(16, $responseItem));
            $planPeriodList[] = $planPeriod;
        }

        return $planPeriodList;
    }
}
