<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetPlanPublicationStatusForUpdate extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $statusData = $this->_getProperty(0, $responseArray);

        $status = new Service_PbaApi_Api_Response_Struct_PlanPublicationStatus();
        $status->setPublished($this->_getProperty(0, $statusData));
        $status->setShowPriority($this->_getProperty(1, $statusData));
        $status->setDefaultPlanPeriodId($this->_getProperty(2, $statusData));
        $status->setImage($this->_getProperty(3, $statusData));

        return $status;
    }
}
