<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetPlanRates extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $listData = $this->_getProperty(0, $responseArray);

        $list = array();
        foreach ($listData as $itemData) {
            $item = new Service_PbaApi_Api_Response_Struct_PlanRate();
            $item->setRateId($this->_getProperty(0, $itemData));
            $item->setResourceName($this->_getProperty(1, $itemData));
            $item->setIncludedValue($this->_getProperty(2, $itemData));
            $item->setMaxValue($this->_getProperty(3, $itemData));
            $item->setUnitOfMeasure($this->_getProperty(4, $itemData));
            $item->setSetupCost($this->_getProperty(5, $itemData));
            $item->setSetupFee($this->moneyToFloat($this->_getProperty(6, $itemData)));
            $item->setSetupFeeIcon($this->_getProperty(7, $itemData));
            $item->setMSRPSetupFee($this->_getProperty(8, $itemData));
            $item->setIsSFPerUnit($this->_getProperty(9, $itemData));
            $item->setRecurringCost($this->_getProperty(10, $itemData));
            $item->setRecurringFee($this->moneyToFloat($this->_getProperty(11, $itemData)));
            $item->setRecurringFeeIcon($this->_getProperty(12, $itemData));
            $item->setMSRPRecurringFee($this->_getProperty(13, $itemData));
            $item->setIsRFPerUnit($this->_getProperty(14, $itemData));
            $item->setOveruseFeeCost($this->_getProperty(15, $itemData));
            $item->setOveruseFee($this->moneyToFloat($this->_getProperty(16, $itemData)));
            $item->setOveruseFeeIcon($this->_getProperty(17, $itemData));
            $item->setMSRPOveruseFee($this->_getProperty(18, $itemData));
            $item->setIsMain($this->_getProperty(19, $itemData));
            $item->setIsVisible($this->_getProperty(20, $itemData));
            $item->setResourceType($this->_getProperty(21, $itemData));
            $item->setStoreText($this->_getProperty(22, $itemData));
            $item->setStorePriceText($this->_getProperty(23, $itemData));
            $item->setStoreSortOrder($this->_getProperty(24, $itemData));
            $item->setSetupSKU($this->_getProperty(25, $itemData));
            $item->setRecurringSKU($this->_getProperty(26, $itemData));
            $item->setOveruseSKU($this->_getProperty(27, $itemData));
            $item->setCancellationSKU($this->_getProperty(28, $itemData));
            $item->setResourceId($this->_getProperty(29, $itemData));
            $list[] = $item;
        }
        return $list;
    }

    private function moneyToFloat($money)
    {
        return floatval(end(explode(' ', $money)));
    }
}
