<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetSubscriptionDetails extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_Struct_SubscriptionDetailsInterface
     * @throws Service_PbaApi_Client_InvalidPropertyException
     */
    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $subscriptionData = $this->_getProperty(0, $responseArray);

        $subscription = new Service_PbaApi_Api_Response_Struct_SubscriptionDetails();
        $subscription->setSubscriptionId($this->_getProperty(0, $subscriptionData));
        $subscription->setSubscriptionName($this->_getProperty(1, $subscriptionData));
        $subscription->setAccountId($this->_getProperty(2, $subscriptionData));
        $subscription->setPlanId($this->_getProperty(3, $subscriptionData));
        $subscription->setPlanName($this->_getProperty(4, $subscriptionData));
        $subscription->setStatus($this->_getProperty(5, $subscriptionData));
        $subscription->setServStatus($this->_getProperty(6, $subscriptionData));

        return $subscription;
    }
}
