<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetSubscriptionSalesOrdersList extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $list = array();
        $listData = $this->_getProperty(0, $responseArray);
        foreach ($listData as $itemData) {
            $item = new Service_PbaApi_Api_Response_Struct_GetSubscriptionSalesOrdersList();
            $item->setOrderId($this->_getProperty(0, $itemData));
            $item->setOrderNumber($this->_getProperty(1, $itemData, false));
            $item->setOrderName($this->_getProperty(2, $itemData, false));
            $item->setOrderDate($this->_getProperty(3, $itemData, false));
            $item->setStatusIcon($this->_getProperty(4, $itemData, false));
            $item->setStatusName($this->_getProperty(5, $itemData, false));
            $item->setTotal($this->_getProperty(6, $itemData, false));
            $item->setWaitTime($this->_getProperty(7, $itemData, false));
            $item->setUpdatedBy($this->_getProperty(8, $itemData, false));
            $list[] = $item;
        }
        return $list;
    }
}
