<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_Struct_AvailablePlanListItem implements
    Service_PbaApi_Api_Response_Struct_AvailablePlanListItemInterface
{
    /**
     *  @var int service plan ID
     */
    private $_planId;

    /**
     * @var string service plan name
     */
    private $_name;

    /**
     * @var string service plan short description
     */
    private $_shortDescription;

    /**
     * @var string service plan long description
     */
    private $_longDescription;

    /**
     * @var int ID of service plan plan category
     */
    private $_planCategoryId;

    /**
     * @var string name of service gate the service plan is provisioned through
     */
    private $_stType;

    /**
     * @var int signifies if service plan is published or not, disabled by its service template or by provider:
     * "0" - published,
     * "1" - not published,
     * "2" - disabled by Template,
     * "3" - not published and disabled by template;
     * "4" - disabled by provider;
     * "5" - not published and disabled by provider;
     * "6" - disabled by provider and by template;
     * "7" - not published and disabled by provider and by template
     */
    private $_isPublished;

    /**
     * @var int ID of unique group service plan belongs to
     */
    private $_groupId;

    /**
     * @var int service plan recurring fee collection method (Charge for Subscription parameter):
     * "10" - before billing period;
     * "20" - after billing period;
     * "30" - before subscription period;
     * "40" - in the end of month
     */
    private $_recurringType;

    /**
     * @var int service plan billing period type:
     * "2" - billing period is a fixed number of months;
     * "3" - billing period is a fixed number of years;
     * "4" - subscription is billed monthly on statement cycle date
     */
    private $_billingPeriodType;

    /**
     * @var int service plan billing period
     */
    private $_billingPeriod;

    /**
     * @var int signifies if parent subscription is required for this type of service.
     * Parent subscription is required if service plan is sold as up-sale to another one
     */
    private $_isParentReq;

    /**
     * @var int order number of service plan in online store
     */
    private $_showPriority;

    /**
     * @var int ID of default subscription period of service plan. Used in online store
     */
    private $_defaultPlanPeriodId;

    /**
     * @return int
     */
    public function getPlanId()
    {
        return $this->_planId;
    }

    /**
     * @param int $planId
     */
    public function setPlanId($planId)
    {
        $this->_planId = $planId;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->_name;
    }

    /**
     * @param string $name
     */
    public function setName($name)
    {
        $this->_name = $name;
    }

    /**
     * @return string
     */
    public function getShortDescription()
    {
        return $this->_shortDescription;
    }

    /**
     * @param string $shortDescription
     */
    public function setShortDescription($shortDescription)
    {
        $this->_shortDescription = $shortDescription;
    }

    /**
     * @return string
     */
    public function getLongDescription()
    {
        return $this->_longDescription;
    }

    /**
     * @param string $longDescription
     */
    public function setLongDescription($longDescription)
    {
        $this->_longDescription = $longDescription;
    }

    /**
     * @return int
     */
    public function getPlanCategoryId()
    {
        return $this->_planCategoryId;
    }

    /**
     * @param int $planCategoryId
     */
    public function setPlanCategoryId($planCategoryId)
    {
        $this->_planCategoryId = $planCategoryId;
    }

    /**
     * @return string
     */
    public function getStType()
    {
        return $this->_stType;
    }

    /**
     * @param string $stType
     */
    public function setStType($stType)
    {
        $this->_stType = $stType;
    }

    /**
     * @return int
     */
    public function getIsPublished()
    {
        return $this->_isPublished;
    }

    /**
     * @param int $isPublished
     */
    public function setIsPublished($isPublished)
    {
        $this->_isPublished = $isPublished;
    }

    /**
     * @return int
     */
    public function getGroupId()
    {
        return $this->_groupId;
    }

    /**
     * @param int $groupId
     */
    public function setGroupId($groupId)
    {
        $this->_groupId = $groupId;
    }

    /**
     * @return int
     */
    public function getRecurringType()
    {
        return $this->_recurringType;
    }

    /**
     * @param int $recurringType
     */
    public function setRecurringType($recurringType)
    {
        $this->_recurringType = $recurringType;
    }

    /**
     * @return int
     */
    public function getBillingPeriodType()
    {
        return $this->_billingPeriodType;
    }

    /**
     * @param int $billingPeriodType
     */
    public function setBillingPeriodType($billingPeriodType)
    {
        $this->_billingPeriodType = $billingPeriodType;
    }

    /**
     * @return int
     */
    public function getBillingPeriod()
    {
        return $this->_billingPeriod;
    }

    /**
     * @param int $billingPeriod
     */
    public function setBillingPeriod($billingPeriod)
    {
        $this->_billingPeriod = $billingPeriod;
    }

    /**
     * @return int
     */
    public function getIsParentReq()
    {
        return $this->_isParentReq;
    }

    /**
     * @param int $isParentReq
     */
    public function setIsParentReq($isParentReq)
    {
        $this->_isParentReq = $isParentReq;
    }

    /**
     * @return int
     */
    public function getShowPriority()
    {
        return $this->_showPriority;
    }

    /**
     * @param int $showPriority
     */
    public function setShowPriority($showPriority)
    {
        $this->_showPriority = $showPriority;
    }

    /**
     * @return int
     */
    public function getDefaultPlanPeriodId()
    {
        return $this->_defaultPlanPeriodId;
    }

    /**
     * @param int $defaultPlanPeriodId
     */
    public function setDefaultPlanPeriodId($defaultPlanPeriodId)
    {
        $this->_defaultPlanPeriodId = $defaultPlanPeriodId;
    }
}
