<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_Struct_GetAndValidatePlanParams
{
    /**
     * parameter is valid;
     */
    const PARAMETER_VALIDATION_STATUS_VALID = '0';

    /**
     * parameter value is absent and need to be asked;
     */
    const PARAMETER_VALIDATION_STATUS_ABSENT = '1';

    /**
     * parameter is invalid (see details in Message slot);
     */
    const PARAMETER_VALIDATION_STATUS_INVALID = '2';

    /**
     * parameter value is not needed for service provisioning;
     */
    const PARAMETER_VALIDATION_STATUS_NOT_NEEDED = '3';

    /**
     * ID of ST service parameter;
     * @var string
     */
    private $parameterId;

    /**
     * Type ST of service parameter;
     * @var string
     */
    private $parameterType;

    /**
     * Name of ST service parameter.
     * @var string
     */
    private $parameterName;

    /**
     * Description of ST service parameter;
     * @var string
     */
    private $description;

    /**
     * If parameter has default value, returns this value.
     * For example, default value for 'OrderOperationType' parameter of domain ST is '10' (registration);
     * @var string
     */
    private $defaultValue;

    /**
     * Signifies if parameter is required: '1' – required, '0' – not required;
     * @var int
     */
    private $required;

    /**
     * Parameter validation status:
     * '0' – parameter is valid;
     * '1' – parameter value is absent and need to be asked;
     * '2' – parameter is invalid (see details in Message slot);
     * '3' – parameter value is not needed for service provisioning;
     * @var int
     */
    private $status;

    /**
     * Parameter validation result;
     * @var string
     */
    private $message;

    /**
     * Service parameter sort order in online store and CP.
     * @var int
     */
    private $serviceTemplateParameterWeight;

    /**
     * @return string
     */
    public function getParameterId()
    {
        return $this->parameterId;
    }

    /**
     * @param string $parameterId
     */
    public function setParameterId($parameterId)
    {
        $this->parameterId = $parameterId;
    }

    /**
     * @return string
     */
    public function getParameterType()
    {
        return $this->parameterType;
    }

    /**
     * @param string $parameterType
     */
    public function setParameterType($parameterType)
    {
        $this->parameterType = $parameterType;
    }

    /**
     * @return string
     */
    public function getParameterName()
    {
        return $this->parameterName;
    }

    /**
     * @param string $parameterName
     */
    public function setParameterName($parameterName)
    {
        $this->parameterName = $parameterName;
    }

    /**
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }

    /**
     * @return string
     */
    public function getDefaultValue()
    {
        return $this->defaultValue;
    }

    /**
     * @param string $defaultValue
     */
    public function setDefaultValue($defaultValue)
    {
        $this->defaultValue = $defaultValue;
    }

    /**
     * @return int
     */
    public function getRequired()
    {
        return $this->required;
    }

    /**
     * @param int $required
     */
    public function setRequired($required)
    {
        $this->required = $required;
    }

    /**
     * @return int
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * @param int $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }

    /**
     * @return string
     */
    public function getMessage()
    {
        return $this->message;
    }

    /**
     * @param string $message
     */
    public function setMessage($message)
    {
        $this->message = $message;
    }

    /**
     * @return int
     */
    public function getServiceTemplateParameterWeight()
    {
        return $this->serviceTemplateParameterWeight;
    }

    /**
     * @param int $serviceTemplateParameterWeight
     */
    public function setServiceTemplateParameterWeight($serviceTemplateParameterWeight)
    {
        $this->serviceTemplateParameterWeight = $serviceTemplateParameterWeight;
    }
}
