<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_Struct_SubscriptionDetails implements Service_PbaApi_Api_Response_Struct_SubscriptionDetailsInterface
{
    /**
     * @var int - subscription ID;
     */
    private $_subscriptionId;

    /**
     * @var string - subscription name;
     */
    private $_subscriptionName;

    /**
     * @var int - ID of account the subscription belongs to;
     */
    private $_accountId;

    /**
     * @var int - subscription service plan ID;
     */
    private $_planId;

    /**
     * @var string - subscription service plan name.
     */
    private $_planName;

    /**
     * @var int - subscription status.
     * Possible values:
     * 10 - "Ordered"
     * 15 - "Trial"
     * 30 - "Active"
     * 40 - "Graced"
     * 50 - "Expired"
     * 60 - "Terminated"
     * 70 - "Canceled"
     * 80 - "Administrative Hold"
     * 85 - "Credit Hold"
     * 89 - "Credit and  Administrative Hold"
     */
    private $_status;

    /**
     * @var int - subscription service current status.
     * Possible values:
     * 10 - Not Provisioned
     * 20 - Provisioning
     * 30 - Stopped
     * 40 - Starting
     * 50 - Running
     * 60 - Stopping
     * 70 - Removing
     * 80 - Changing Plan
     * 90 - Removed
     */
    private $_servStatus;

    /**
     * @return int
     */
    public function getSubscriptionId()
    {
        return $this->_subscriptionId;
    }

    /**
     * @param int $subscriptionId
     */
    public function setSubscriptionId($subscriptionId)
    {
        $this->_subscriptionId = $subscriptionId;
    }

    /**
     * @return string
     */
    public function getSubscriptionName()
    {
        return $this->_subscriptionName;
    }

    /**
     * @param string $subscriptionName
     */
    public function setSubscriptionName($subscriptionName)
    {
        $this->_subscriptionName = $subscriptionName;
    }

    /**
     * @return int
     */
    public function getAccountId()
    {
        return $this->_accountId;
    }

    /**
     * @param int $accountId
     */
    public function setAccountId($accountId)
    {
        $this->_accountId = $accountId;
    }

    /**
     * @return int
     */
    public function getPlanId()
    {
        return $this->_planId;
    }

    /**
     * @param int $planId
     */
    public function setPlanId($planId)
    {
        $this->_planId = $planId;
    }

    /**
     * @return string
     */
    public function getPlanName()
    {
        return $this->_planName;
    }

    /**
     * @param string $planName
     */
    public function setPlanName($planName)
    {
        $this->_planName = $planName;
    }

    /**
     * @return int
     */
    public function getStatus()
    {
        return $this->_status;
    }

    /**
     * @param int $status
     */
    public function setStatus($status)
    {
        $this->_status = $status;
    }

    /**
     * @return int
     */
    public function getServStatus()
    {
        return $this->_servStatus;
    }

    /**
     * @param int $servStatus
     */
    public function setServStatus($servStatus)
    {
        $this->_servStatus = $servStatus;
    }
}
