<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Services\Logger;

use Acronis\App\Services\Config\ConfigAwareTrait;
use Acronis\App\Services\FactoryInterface;
use Monolog\ErrorHandler;
use Monolog\Logger;

class LoggerFactory implements FactoryInterface
{
    use ConfigAwareTrait;

    const NAME = 'logger';

    /**
     * @return Logger
     */
    public function createInstance()
    {
        $logger = \Log::getInstance()->getLogger();
        $logger->pushProcessor(new TokenProtectProcessor());
        $logger->pushProcessor(new PasswordProtectProcessor());

        ErrorHandler::register($logger);

        return $logger;
    }
}