<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\UsageReport;

use Acronis\App\Services\Cache\CacheAwareTrait;
use Acronis\App\Services\Cache\CacheInterface;

class ReportCache implements CacheInterface
{
    use CacheAwareTrait;

    private $reportPrefix;

    public function __construct($reportPrefix)
    {
        $this->reportPrefix = $reportPrefix;
    }

    public function set($key, $value, $ttl = null)
    {
        $this->getCache()->set($this->formatKey($key), $value, $ttl);
    }

    public function get($key, $default = null)
    {
        return $this->getCache()->get($this->formatKey($key), $default);
    }

    public function has($key)
    {
        return $this->getCache()->has($this->formatKey($key));
    }

    public function refresh($key, $ttl)
    {
        return $this->getCache()->refresh($key, $ttl);
    }

    private function formatKey($key)
    {
        return $this->reportPrefix . $key;
    }
}