<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Utils;

use Arr;

class Fn
{
    /**
     * @param int $deep
     * @return string
     */
    public static function getCallerName($deep = 2)
    {
        $backtrace = debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS, $deep + 1);
        $callerInfo = Arr::get($backtrace, $deep);

        if (!isset($callerInfo['function'])) {
            throw new \RuntimeException('Unable to resolve a caller name.');
        }

        if (isset($callerInfo['class'])) {
            return $callerInfo['class'] . '::' . $callerInfo['function'];
        }

        return $callerInfo['function'];
    }
}