SELECT
  round(
      SUM(br."ExtendedPrice") * cr."DistrDiscount",
      br."CurrencyPrecision"
  ) AS "Discount"
FROM
  "AcronisServiceProviderBreakdown" AS br
  JOIN
  (
    SELECT
      a."AccountID",

      CASE WHEN dd."Value" IS NULL
        THEN 0.0
      ELSE CAST(TRIM(BOTH '%' FROM dd."Value") AS DECIMAL) / 100 END AS "DistrDiscount"

    FROM
      "Account" a
      LEFT JOIN "AccAttr" AS dd ON dd."ObjID" = a."AccountID" AND dd."ATID" = 'DistrDiscount'
    WHERE
      a."VendorAccountID" = :CR_VENDOR_ID
  ) AS cr ON cr."AccountID" = br."VendorAccountID"
WHERE
  br."ResourceSKU" IS NOT NULL
GROUP BY
  cr."DistrDiscount",
  br."CurrencyPrecision";