<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

require_once(__DIR__ . '/app/bootstrap.php');

/**
 * Class tenant
 * @type("http://acronis.com/aps/cloud-backup-v1/tenant/9.5")
 * @implements("http://aps-standard.org/types/core/resource/1.0")
 * @implements("http://aps-standard.org/types/core/suspendable/1.0")
 * @implements("http://aps-standard.org/types/core/subscription/service/1.0")
 */
class tenantAcronis extends tenantCCPv2
{
    const TYPE_EXTERNAL = 'EXTERNAL';

    /* ======= RESOURCE PROPERTIES ======= */

    /**
     * @type(boolean)
     * @readonly
     */
    public $wsDiscount = false;

    /* ======= OTHER PROPERTIES ======= */

    /* ======= RESOURCE METHODS ======= */

    /* ======= RESOURCE EVENTS ======= */

    /* ======= RESOURCE OPERATIONS ======= */

    /* ======= OTHER METHODS ======= */

    /**
     * @return Model_Resource_TenantInterface
     * @throws Exception
     */
    protected function getTenantStrategy()
    {
        switch ($this->type) {
            case self::TYPE_EXTERNAL:
                return new Model_Resource_Tenant_AcronisExternal($this, $this->_apsc, $this->_facade, $this->_managerFactory);
            case self::TYPE_PARTNER:
                return new Model_Resource_Tenant_AcronisPartner($this, $this->_apsc, $this->_facade, $this->_managerFactory);
            case self::TYPE_CUSTOMER:
                return new Model_Resource_Tenant_AcronisCustomer($this, $this->_apsc, $this->_facade, $this->_managerFactory);
            default:
                throw new Exception(Str::format('Unsupported type "%s".', $this->type));
        }
    }

    protected function initializeTenantType()
    {
        $subscriptionParametersManager = $this->_managerFactory->getSubscriptionParametersManager($this->_getPbaApi());
        $isExternalGroup = $subscriptionParametersManager->getParameterIsExternal($this->subscription->subscriptionId);
        if ($isExternalGroup) {
            $this->type = self::TYPE_EXTERNAL;
            return;
        }
        parent::initializeTenantType();
    }
}
