# Swagger\Client\AccessApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteAccessPoliciesByAccessPolicyId**](AccessApi.md#deleteAccessPoliciesByAccessPolicyId) | **DELETE** /access_policies/{access_policy_id} | AccessPoliciesByAccessPolicyId
[**getAccessPolicies**](AccessApi.md#getAccessPolicies) | **GET** /access_policies | AccessPolicies
[**getAccessPoliciesByAccessPolicyId**](AccessApi.md#getAccessPoliciesByAccessPolicyId) | **GET** /access_policies/{access_policy_id} | AccessPoliciesByAccessPolicyId


# **deleteAccessPoliciesByAccessPolicyId**
> deleteAccessPoliciesByAccessPolicyId($access_policy_id, $_issues)

AccessPoliciesByAccessPolicyId

Delete access policy by ID

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\AccessApi();
$access_policy_id = "access_policy_id_example"; // string | 
$_issues = "_issues_example"; // string | 

try {
    $api_instance->deleteAccessPoliciesByAccessPolicyId($access_policy_id, $_issues);
} catch (Exception $e) {
    echo 'Exception when calling AccessApi->deleteAccessPoliciesByAccessPolicyId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **access_policy_id** | **string**|  |
 **_issues** | **string**|  | [optional]

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getAccessPolicies**
> \Swagger\Client\Model\AccessPolicies\AccessPoliciesList getAccessPolicies($users, $if_modified_since)

AccessPolicies

List access policies.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\AccessApi();
$users = "users_example"; // string | Return access policies for users with specified UUIDs
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getAccessPolicies($users, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AccessApi->getAccessPolicies: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **users** | **string**| Return access policies for users with specified UUIDs |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\AccessPolicies\AccessPoliciesList**](../Model/AccessPolicies/AccessPoliciesList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getAccessPoliciesByAccessPolicyId**
> \Swagger\Client\Model\AccessPolicies\AccessPolicy getAccessPoliciesByAccessPolicyId($access_policy_id, $_issues, $if_modified_since)

AccessPoliciesByAccessPolicyId

Get Access Policy by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\AccessApi();
$access_policy_id = "access_policy_id_example"; // string | 
$_issues = "_issues_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getAccessPoliciesByAccessPolicyId($access_policy_id, $_issues, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling AccessApi->getAccessPoliciesByAccessPolicyId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **access_policy_id** | **string**|  |
 **_issues** | **string**|  | [optional]
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\AccessPolicies\AccessPolicy**](../Model/AccessPolicies/AccessPolicy.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

