# Swagger\Client\ApplicationsApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteApplicationsBindingsTenants**](ApplicationsApi.md#deleteApplicationsBindingsTenants) | **DELETE** /applications/{application_id}/bindings/tenants/{tenant_id} | ApplicationsBindingsTenants
[**deleteApplicationsSettingsTenantsSettingName**](ApplicationsApi.md#deleteApplicationsSettingsTenantsSettingName) | **DELETE** /applications/{application_id}/settings/tenants/{tenant_id}/{setting_name} | ApplicationsSettingsTenantsSettingName
[**deleteApplicationsSettingsUsersSettingName**](ApplicationsApi.md#deleteApplicationsSettingsUsersSettingName) | **DELETE** /applications/{application_id}/settings/users/{user_id}/{setting_name} | ApplicationsSettingsUsersSettingName
[**getApplications**](ApplicationsApi.md#getApplications) | **GET** /applications | Applications
[**getApplicationsByApplicationId**](ApplicationsApi.md#getApplicationsByApplicationId) | **GET** /applications/{application_id} | ApplicationsByApplicationId
[**getApplicationsResourceServers**](ApplicationsApi.md#getApplicationsResourceServers) | **GET** /applications/{application_id}/resource_servers | ApplicationsResourceServers
[**getApplicationsSettingsSchemas**](ApplicationsApi.md#getApplicationsSettingsSchemas) | **GET** /applications/{application_id}/settings/schemas | ApplicationsSettingsSchemas
[**getApplicationsSettingsTenants**](ApplicationsApi.md#getApplicationsSettingsTenants) | **GET** /applications/{application_id}/settings/tenants/{tenant_id} | ApplicationsSettingsTenants
[**getApplicationsSettingsTenantsSettingName**](ApplicationsApi.md#getApplicationsSettingsTenantsSettingName) | **GET** /applications/{application_id}/settings/tenants/{tenant_id}/{setting_name} | ApplicationsSettingsTenantsSettingName
[**getApplicationsSettingsTenants_0**](ApplicationsApi.md#getApplicationsSettingsTenants_0) | **GET** /applications/{application_id}/settings/tenants | ApplicationsSettingsTenants
[**getApplicationsSettingsUsersByApplicationId**](ApplicationsApi.md#getApplicationsSettingsUsersByApplicationId) | **GET** /applications/{application_id}/settings/users/{user_id} | ApplicationsSettingsUsersByApplicationId
[**getApplicationsSettingsUsersSettingName**](ApplicationsApi.md#getApplicationsSettingsUsersSettingName) | **GET** /applications/{application_id}/settings/users/{user_id}/{setting_name} | ApplicationsSettingsUsersSettingName
[**postApplicationsBindingsTenants**](ApplicationsApi.md#postApplicationsBindingsTenants) | **POST** /applications/{application_id}/bindings/tenants/{tenant_id} | ApplicationsBindingsTenants
[**putApplicationsSettingsTenantsSettingName**](ApplicationsApi.md#putApplicationsSettingsTenantsSettingName) | **PUT** /applications/{application_id}/settings/tenants/{tenant_id}/{setting_name} | ApplicationsSettingsTenantsSettingName
[**putApplicationsSettingsUsersSettingName**](ApplicationsApi.md#putApplicationsSettingsUsersSettingName) | **PUT** /applications/{application_id}/settings/users/{user_id}/{setting_name} | ApplicationsSettingsUsersSettingName


# **deleteApplicationsBindingsTenants**
> deleteApplicationsBindingsTenants($application_id, $tenant_id)

ApplicationsBindingsTenants

Turn application off for tenant

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$tenant_id = "tenant_id_example"; // string | Tenant UUID

try {
    $api_instance->deleteApplicationsBindingsTenants($application_id, $tenant_id);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->deleteApplicationsBindingsTenants: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **tenant_id** | **string**| Tenant UUID |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deleteApplicationsSettingsTenantsSettingName**
> deleteApplicationsSettingsTenantsSettingName($application_id, $tenant_id, $setting_name)

ApplicationsSettingsTenantsSettingName

Delete own setting.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$tenant_id = "tenant_id_example"; // string | 
$setting_name = "setting_name_example"; // string | 

try {
    $api_instance->deleteApplicationsSettingsTenantsSettingName($application_id, $tenant_id, $setting_name);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->deleteApplicationsSettingsTenantsSettingName: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **tenant_id** | **string**|  |
 **setting_name** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deleteApplicationsSettingsUsersSettingName**
> deleteApplicationsSettingsUsersSettingName($application_id, $user_id, $setting_name)

ApplicationsSettingsUsersSettingName

Delete own setting.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$user_id = "user_id_example"; // string | 
$setting_name = "setting_name_example"; // string | 

try {
    $api_instance->deleteApplicationsSettingsUsersSettingName($application_id, $user_id, $setting_name);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->deleteApplicationsSettingsUsersSettingName: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **user_id** | **string**|  |
 **setting_name** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getApplications**
> \Swagger\Client\Model\Applications\ApplicationsList getApplications($if_modified_since)

Applications

Get info about all registered applications

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getApplications($if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->getApplications: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Applications\ApplicationsList**](../Model/Applications/ApplicationsList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getApplicationsByApplicationId**
> \Swagger\Client\Model\Applications\Application getApplicationsByApplicationId($application_id, $if_modified_since)

ApplicationsByApplicationId

Get info about a specific application by its id

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getApplicationsByApplicationId($application_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->getApplicationsByApplicationId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Applications\Application**](../Model/Applications/Application.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getApplicationsResourceServers**
> \Swagger\Client\Model\Common\ModelList getApplicationsResourceServers($application_id, $if_modified_since)

ApplicationsResourceServers

List registered resource servers.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getApplicationsResourceServers($application_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->getApplicationsResourceServers: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Common\ModelList**](../Model/Common/ModelList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getApplicationsSettingsSchemas**
> \Swagger\Client\Model\Settings\SettingSchemaList getApplicationsSettingsSchemas($application_id, $if_modified_since)

ApplicationsSettingsSchemas

Get effective settings for the given tenant.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getApplicationsSettingsSchemas($application_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->getApplicationsSettingsSchemas: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Settings\SettingSchemaList**](../Model/Settings/SettingSchemaList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getApplicationsSettingsTenants**
> \Swagger\Client\Model\Settings\SettingList getApplicationsSettingsTenants($application_id, $tenant_id, $if_modified_since)

ApplicationsSettingsTenants

Get effective application instance settings for a given tenant.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$tenant_id = "tenant_id_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getApplicationsSettingsTenants($application_id, $tenant_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->getApplicationsSettingsTenants: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **tenant_id** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Settings\SettingList**](../Model/Settings/SettingList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getApplicationsSettingsTenantsSettingName**
> \Swagger\Client\Model\Settings\Setting getApplicationsSettingsTenantsSettingName($application_id, $tenant_id, $setting_name, $if_modified_since)

ApplicationsSettingsTenantsSettingName

Get effective & own setting.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$tenant_id = "tenant_id_example"; // string | 
$setting_name = "setting_name_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getApplicationsSettingsTenantsSettingName($application_id, $tenant_id, $setting_name, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->getApplicationsSettingsTenantsSettingName: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **tenant_id** | **string**|  |
 **setting_name** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Settings\Setting**](../Model/Settings/Setting.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getApplicationsSettingsTenants_0**
> \Swagger\Client\Model\Settings\SettingTenantList getApplicationsSettingsTenants_0($application_id, $uuids)

ApplicationsSettingsTenants

Get settings for tenants in batch, used in Cloud version

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$uuids = "uuids_example"; // string | Return information for tenants with specified UUIDS

try {
    $result = $api_instance->getApplicationsSettingsTenants_0($application_id, $uuids);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->getApplicationsSettingsTenants_0: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **uuids** | **string**| Return information for tenants with specified UUIDS |

### Return type

[**\Swagger\Client\Model\Settings\SettingTenantList**](../Model/Settings/SettingTenantList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getApplicationsSettingsUsersByApplicationId**
> \Swagger\Client\Model\Settings\SettingList getApplicationsSettingsUsersByApplicationId($application_id, $user_id, $if_modified_since)

ApplicationsSettingsUsersByApplicationId

Update application instance settings for the given user.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$user_id = "user_id_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getApplicationsSettingsUsersByApplicationId($application_id, $user_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->getApplicationsSettingsUsersByApplicationId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **user_id** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Settings\SettingList**](../Model/Settings/SettingList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getApplicationsSettingsUsersSettingName**
> \Swagger\Client\Model\Settings\Setting getApplicationsSettingsUsersSettingName($application_id, $user_id, $setting_name, $if_modified_since)

ApplicationsSettingsUsersSettingName

Get effective & own setting.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$user_id = "user_id_example"; // string | 
$setting_name = "setting_name_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getApplicationsSettingsUsersSettingName($application_id, $user_id, $setting_name, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->getApplicationsSettingsUsersSettingName: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **user_id** | **string**|  |
 **setting_name** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Settings\Setting**](../Model/Settings/Setting.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postApplicationsBindingsTenants**
> postApplicationsBindingsTenants($application_id, $tenant_id)

ApplicationsBindingsTenants

Turn application on for tenant

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$tenant_id = "tenant_id_example"; // string | Tenant UUID

try {
    $api_instance->postApplicationsBindingsTenants($application_id, $tenant_id);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->postApplicationsBindingsTenants: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **tenant_id** | **string**| Tenant UUID |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putApplicationsSettingsTenantsSettingName**
> \Swagger\Client\Model\Settings\Setting putApplicationsSettingsTenantsSettingName($application_id, $tenant_id, $setting_name, $body)

ApplicationsSettingsTenantsSettingName

Update own setting.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$tenant_id = "tenant_id_example"; // string | 
$setting_name = "setting_name_example"; // string | 
$body = new \Swagger\Client\Model\Settings\SettingPut(); // \Swagger\Client\Model\Settings\SettingPut | 

try {
    $result = $api_instance->putApplicationsSettingsTenantsSettingName($application_id, $tenant_id, $setting_name, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->putApplicationsSettingsTenantsSettingName: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **tenant_id** | **string**|  |
 **setting_name** | **string**|  |
 **body** | [**\Swagger\Client\Model\Settings\SettingPut**](../Model/Settings/SettingPut.md)|  |

### Return type

[**\Swagger\Client\Model\Settings\Setting**](../Model/Settings/Setting.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putApplicationsSettingsUsersSettingName**
> \Swagger\Client\Model\Settings\Setting putApplicationsSettingsUsersSettingName($application_id, $user_id, $setting_name, $body)

ApplicationsSettingsUsersSettingName

Update own setting.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\ApplicationsApi();
$application_id = "application_id_example"; // string | Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively.
$user_id = "user_id_example"; // string | 
$setting_name = "setting_name_example"; // string | 
$body = new \Swagger\Client\Model\Settings\SettingPut(); // \Swagger\Client\Model\Settings\SettingPut | 

try {
    $result = $api_instance->putApplicationsSettingsUsersSettingName($application_id, $user_id, $setting_name, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ApplicationsApi->putApplicationsSettingsUsersSettingName: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **application_id** | **string**| Application UUID, e. g. Acronis Cloud in general, Acronis Backup Cloud and Acronis Access will have their own ids respectively. |
 **user_id** | **string**|  |
 **setting_name** | **string**|  |
 **body** | [**\Swagger\Client\Model\Settings\SettingPut**](../Model/Settings/SettingPut.md)|  |

### Return type

[**\Swagger\Client\Model\Settings\Setting**](../Model/Settings/Setting.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

