# Swagger\Client\IdpApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteIdpIdentitiesByIdentityId**](IdpApi.md#deleteIdpIdentitiesByIdentityId) | **DELETE** /idp/identities/{identity_id} | IdpIdentitiesByIdentityId
[**deleteIdpSessionsById**](IdpApi.md#deleteIdpSessionsById) | **DELETE** /idp/sessions/{id} | IdpSessionsById
[**getIdpAuthorize**](IdpApi.md#getIdpAuthorize) | **GET** /idp/authorize | IdpAuthorize
[**getIdpDeviceAuthorizationApproval**](IdpApi.md#getIdpDeviceAuthorizationApproval) | **GET** /idp/device_authorization/approval | IdpDeviceAuthorizationApproval
[**getIdpIdentitiesByIdentityId**](IdpApi.md#getIdpIdentitiesByIdentityId) | **GET** /idp/identities/{identity_id} | IdpIdentitiesByIdentityId
[**getIdpKeys**](IdpApi.md#getIdpKeys) | **GET** /idp/keys | IdpKeys
[**getIdpLogout**](IdpApi.md#getIdpLogout) | **GET** /idp/logout | IdpLogout
[**getIdpSessions**](IdpApi.md#getIdpSessions) | **GET** /idp/sessions | IdpSessions
[**postIdpDeviceAuthorization**](IdpApi.md#postIdpDeviceAuthorization) | **POST** /idp/device_authorization | IdpDeviceAuthorization
[**postIdpDeviceAuthorizationApproval**](IdpApi.md#postIdpDeviceAuthorizationApproval) | **POST** /idp/device_authorization/approval | IdpDeviceAuthorizationApproval
[**postIdpIdentities**](IdpApi.md#postIdpIdentities) | **POST** /idp/identities | IdpIdentities
[**postIdpPassword**](IdpApi.md#postIdpPassword) | **POST** /idp/password | IdpPassword
[**postIdpToken**](IdpApi.md#postIdpToken) | **POST** /idp/token | IdpToken
[**putIdpIdentitiesByIdentityId**](IdpApi.md#putIdpIdentitiesByIdentityId) | **PUT** /idp/identities/{identity_id} | IdpIdentitiesByIdentityId
[**putIdpPassword**](IdpApi.md#putIdpPassword) | **PUT** /idp/password | IdpPassword


# **deleteIdpIdentitiesByIdentityId**
> deleteIdpIdentitiesByIdentityId($identity_id, $version)

IdpIdentitiesByIdentityId

Delete an identity by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();
$identity_id = "identity_id_example"; // string | 
$version = "version_example"; // string | 

try {
    $api_instance->deleteIdpIdentitiesByIdentityId($identity_id, $version);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->deleteIdpIdentitiesByIdentityId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **identity_id** | **string**|  |
 **version** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deleteIdpSessionsById**
> deleteIdpSessionsById($id)

IdpSessionsById

Revoke user session by id

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();
$id = "id_example"; // string | 

try {
    $api_instance->deleteIdpSessionsById($id);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->deleteIdpSessionsById: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getIdpAuthorize**
> object getIdpAuthorize($scope, $client_id, $redirect_uri, $response_type, $state, $prompt, $id_token_hint)

IdpAuthorize

OpenID Connect 1.0 Authorization Endpoint. The Authorization Endpoint performs Authentication of the End-User. This is done by sending the User Agent to the Authorization Server's Authorization Endpoint for Authentication and Authorization, using request parameters defined by OAuth 2.0 and additional parameters and parameter values defined by OpenId Connect. See http://openid.net/specs/openid-connect-core-1_0.html#AuthorizationEndpoint for details.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();
$scope = "scope_example"; // string | must contain 'scope' and, optionally, other values separated by spaces
$client_id = "client_id_example"; // string | OAuth 2.0 Client Identifier
$redirect_uri = "redirect_uri_example"; // string | redirection URI to which the response will be sent
$response_type = "response_type_example"; // string | corresponds to OpenID Connect 1.0 or OAuth 2.0 Authorization Flows, our IdP currently supports only Authorization Code Flow
$state = "state_example"; // string | opaque value, which client can use to maintain state between the request and the response callback
$prompt = "prompt_example"; // string | space delimited, case sensitive list of string values that specifies whether the IdP prompts the user for reauthentication and consent; our IdP currently supports only the value below
$id_token_hint = "id_token_hint_example"; // string | ID token previously issued by IdP being passed as a hint about the user current or past authenticated session

try {
    $result = $api_instance->getIdpAuthorize($scope, $client_id, $redirect_uri, $response_type, $state, $prompt, $id_token_hint);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->getIdpAuthorize: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **scope** | **string**| must contain &#39;scope&#39; and, optionally, other values separated by spaces |
 **client_id** | **string**| OAuth 2.0 Client Identifier |
 **redirect_uri** | **string**| redirection URI to which the response will be sent |
 **response_type** | **string**| corresponds to OpenID Connect 1.0 or OAuth 2.0 Authorization Flows, our IdP currently supports only Authorization Code Flow | [optional]
 **state** | **string**| opaque value, which client can use to maintain state between the request and the response callback | [optional]
 **prompt** | **string**| space delimited, case sensitive list of string values that specifies whether the IdP prompts the user for reauthentication and consent; our IdP currently supports only the value below | [optional]
 **id_token_hint** | **string**| ID token previously issued by IdP being passed as a hint about the user current or past authenticated session | [optional]

### Return type

**object**

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getIdpDeviceAuthorizationApproval**
> \Swagger\Client\Model\Idp\DeviceCodeApproval getIdpDeviceAuthorizationApproval($code)

IdpDeviceAuthorizationApproval

Information about device code approval request

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();
$code = "code_example"; // string | The end-user verification code.

try {
    $result = $api_instance->getIdpDeviceAuthorizationApproval($code);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->getIdpDeviceAuthorizationApproval: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **code** | **string**| The end-user verification code. |

### Return type

[**\Swagger\Client\Model\Idp\DeviceCodeApproval**](../Model/Idp/DeviceCodeApproval.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getIdpIdentitiesByIdentityId**
> \Swagger\Client\Model\Idp\Identity getIdpIdentitiesByIdentityId($identity_id, $if_modified_since)

IdpIdentitiesByIdentityId

Get an identity by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();
$identity_id = "identity_id_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getIdpIdentitiesByIdentityId($identity_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->getIdpIdentitiesByIdentityId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **identity_id** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Idp\Identity**](../Model/Idp/Identity.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getIdpKeys**
> \Swagger\Client\Model\Idp\Jwks getIdpKeys()

IdpKeys

Returns JSON Web Key Set [JWK] document. See https://tools.ietf.org/html/draft-ietf-jose-json-web-key-41

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();

try {
    $result = $api_instance->getIdpKeys();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->getIdpKeys: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**\Swagger\Client\Model\Idp\Jwks**](../Model/Idp/Jwks.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getIdpLogout**
> object getIdpLogout()

IdpLogout

Log out

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();

try {
    $result = $api_instance->getIdpLogout();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->getIdpLogout: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters
This endpoint does not need any parameter.

### Return type

**object**

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getIdpSessions**
> \Swagger\Client\Model\Idp\Sessions200 getIdpSessions()

IdpSessions

Get current user sessions

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();

try {
    $result = $api_instance->getIdpSessions();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->getIdpSessions: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**\Swagger\Client\Model\Idp\Sessions200**](../Model/Idp/Sessions200.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postIdpDeviceAuthorization**
> \Swagger\Client\Model\Idp\DeviceCode postIdpDeviceAuthorization($client_id, $scope, $display_name)

IdpDeviceAuthorization

OAuth 2.0 Device Flow device authorization endpoint. See https://tools.ietf.org/html/draft-ietf-oauth-device-flow-07#section-3.1 for more details.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();
$client_id = "client_id_example"; // string | The client identifier
$scope = "scope_example"; // string | The scope of the access request
$display_name = "display_name_example"; // string | Device display name

try {
    $result = $api_instance->postIdpDeviceAuthorization($client_id, $scope, $display_name);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->postIdpDeviceAuthorization: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **client_id** | **string**| The client identifier |
 **scope** | **string**| The scope of the access request | [optional]
 **display_name** | **string**| Device display name | [optional]

### Return type

[**\Swagger\Client\Model\Idp\DeviceCode**](../Model/Idp/DeviceCode.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postIdpDeviceAuthorizationApproval**
> postIdpDeviceAuthorizationApproval($body)

IdpDeviceAuthorizationApproval

Approve device code request

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();
$body = new \Swagger\Client\Model\Idp\DeviceCodeApprovalPost(); // \Swagger\Client\Model\Idp\DeviceCodeApprovalPost | 

try {
    $api_instance->postIdpDeviceAuthorizationApproval($body);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->postIdpDeviceAuthorizationApproval: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\Idp\DeviceCodeApprovalPost**](../Model/Idp/DeviceCodeApprovalPost.md)|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postIdpIdentities**
> \Swagger\Client\Model\Idp\Identity postIdpIdentities($body)

IdpIdentities

Create a new identity

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();
$body = new \Swagger\Client\Model\Idp\IdentityPost(); // \Swagger\Client\Model\Idp\IdentityPost | 

try {
    $result = $api_instance->postIdpIdentities($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->postIdpIdentities: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\Idp\IdentityPost**](../Model/Idp/IdentityPost.md)|  |

### Return type

[**\Swagger\Client\Model\Idp\Identity**](../Model/Idp/Identity.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postIdpPassword**
> postIdpPassword($body)

IdpPassword

Create user password

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();
$body = new \Swagger\Client\Model\Idp\PasswordPost(); // \Swagger\Client\Model\Idp\PasswordPost | 

try {
    $api_instance->postIdpPassword($body);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->postIdpPassword: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\Idp\PasswordPost**](../Model/Idp/PasswordPost.md)|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postIdpToken**
> \Swagger\Client\Model\Idp\Token postIdpToken($grant_type, $client_id, $username, $password, $refresh_token, $code, $scope, $assertion, $device_code)

IdpToken

OpenID Connect 1.0 and OAuth 2.0 Token Endpoint. To obtain an Access Token, an ID Token, and optionally a Refresh Token, the RP (Client) sends a Token Request to the Token Endpoint to obtain a Token Response, as described in Section 3.2 of OAuth 2.0 [RFC6749], when using the Authorization Code Flow. See http://openid.net/specs/openid-connect-core-1_0.html#TokenEndpoint for details on OpenID Connect 1.0 'authorization_code', 'refresh_token' and 'client_credentials' grant types. See https://tools.ietf.org/html/rfc6749#section-4.3 for details on OAuth2 'password' grant type (Resource Owner Password Credentials Grant). Headers should contain Basic Authorization for 'client_credentials' grant type

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();
$grant_type = "grant_type_example"; // string | the only always-required parameter; 'password' grant_type implements https://tools.ietf.org/html/rfc6749#section-4.3, 'authorization_code', 'refresh_token' and 'client_credentials' grant_type's implement http://openid.net/specs/openid-connect-core-1_0.html#TokenEndpoint 'urn:ietf:params:oauth:grant-type:device_code' grant type implements https://tools.ietf.org/html/draft-ietf-oauth-device-flow-07 (available only in Backup Account Server) 'urn:ietf:params:oauth:grant-type:jwt-bearer' grant type implements https://tools.ietf.org/html/rfc7523 (available only in Backup Account Server)
$client_id = "client_id_example"; // string | required for grant_type='password' and for grant_type='urn:ietf:params:oauth:grant-type:device_code', not required for other grant_type values
$username = "username_example"; // string | required for 'password' grant_type
$password = "password_example"; // string | required for 'password' grant_type
$refresh_token = "refresh_token_example"; // string | required for 'refresh_token' grant_type
$code = "code_example"; // string | required for 'authorization_code' grant_type
$scope = "scope_example"; // string | Not used for 'authorization_code'. Optional for all other supported grant types.
$assertion = "assertion_example"; // string | required for 'urn:ietf:params:oauth:grant-type:jwt-bearer' grant type
$device_code = "device_code_example"; // string | required for 'urn:ietf:params:oauth:grant-type:device_code' grant type

try {
    $result = $api_instance->postIdpToken($grant_type, $client_id, $username, $password, $refresh_token, $code, $scope, $assertion, $device_code);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->postIdpToken: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **grant_type** | **string**| the only always-required parameter; &#39;password&#39; grant_type implements https://tools.ietf.org/html/rfc6749#section-4.3, &#39;authorization_code&#39;, &#39;refresh_token&#39; and &#39;client_credentials&#39; grant_type&#39;s implement http://openid.net/specs/openid-connect-core-1_0.html#TokenEndpoint &#39;urn:ietf:params:oauth:grant-type:device_code&#39; grant type implements https://tools.ietf.org/html/draft-ietf-oauth-device-flow-07 (available only in Backup Account Server) &#39;urn:ietf:params:oauth:grant-type:jwt-bearer&#39; grant type implements https://tools.ietf.org/html/rfc7523 (available only in Backup Account Server) |
 **client_id** | **string**| required for grant_type&#x3D;&#39;password&#39; and for grant_type&#x3D;&#39;urn:ietf:params:oauth:grant-type:device_code&#39;, not required for other grant_type values | [optional]
 **username** | **string**| required for &#39;password&#39; grant_type | [optional]
 **password** | **string**| required for &#39;password&#39; grant_type | [optional]
 **refresh_token** | **string**| required for &#39;refresh_token&#39; grant_type | [optional]
 **code** | **string**| required for &#39;authorization_code&#39; grant_type | [optional]
 **scope** | **string**| Not used for &#39;authorization_code&#39;. Optional for all other supported grant types. | [optional]
 **assertion** | **string**| required for &#39;urn:ietf:params:oauth:grant-type:jwt-bearer&#39; grant type | [optional]
 **device_code** | **string**| required for &#39;urn:ietf:params:oauth:grant-type:device_code&#39; grant type | [optional]

### Return type

[**\Swagger\Client\Model\Idp\Token**](../Model/Idp/Token.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putIdpIdentitiesByIdentityId**
> \Swagger\Client\Model\Idp\Identity putIdpIdentitiesByIdentityId($identity_id, $body)

IdpIdentitiesByIdentityId

Update an identity by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();
$identity_id = "identity_id_example"; // string | 
$body = new \Swagger\Client\Model\Idp\IdentityPut(); // \Swagger\Client\Model\Idp\IdentityPut | 

try {
    $result = $api_instance->putIdpIdentitiesByIdentityId($identity_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->putIdpIdentitiesByIdentityId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **identity_id** | **string**|  |
 **body** | [**\Swagger\Client\Model\Idp\IdentityPut**](../Model/Idp/IdentityPut.md)|  |

### Return type

[**\Swagger\Client\Model\Idp\Identity**](../Model/Idp/Identity.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putIdpPassword**
> putIdpPassword($body)

IdpPassword

Update user password

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\IdpApi();
$body = new \Swagger\Client\Model\Idp\PasswordPut(); // \Swagger\Client\Model\Idp\PasswordPut | 

try {
    $api_instance->putIdpPassword($body);
} catch (Exception $e) {
    echo 'Exception when calling IdpApi->putIdpPassword: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\Idp\PasswordPut**](../Model/Idp/PasswordPut.md)|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

