# Swagger\Client\RolesApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteRolesByRoleId**](RolesApi.md#deleteRolesByRoleId) | **DELETE** /roles/{role_id} | RolesByRoleId
[**getRolesByRoleId**](RolesApi.md#getRolesByRoleId) | **GET** /roles/{role_id} | RolesByRoleId
[**postRoles**](RolesApi.md#postRoles) | **POST** /roles | Roles
[**putRolesByRoleId**](RolesApi.md#putRolesByRoleId) | **PUT** /roles/{role_id} | RolesByRoleId


# **deleteRolesByRoleId**
> deleteRolesByRoleId($role_id, $version)

RolesByRoleId

Delete a role by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\RolesApi();
$role_id = "role_id_example"; // string | 
$version = "version_example"; // string | 

try {
    $api_instance->deleteRolesByRoleId($role_id, $version);
} catch (Exception $e) {
    echo 'Exception when calling RolesApi->deleteRolesByRoleId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **role_id** | **string**|  |
 **version** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getRolesByRoleId**
> \Swagger\Client\Model\Roles\Role getRolesByRoleId($role_id, $if_modified_since)

RolesByRoleId

Get <<typeName>> by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\RolesApi();
$role_id = "role_id_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getRolesByRoleId($role_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RolesApi->getRolesByRoleId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **role_id** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\Roles\Role**](../Model/Roles/Role.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postRoles**
> \Swagger\Client\Model\Roles\Role postRoles($body)

Roles

Create a new role

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\RolesApi();
$body = new \Swagger\Client\Model\Roles\RolePost(); // \Swagger\Client\Model\Roles\RolePost | 

try {
    $result = $api_instance->postRoles($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RolesApi->postRoles: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\Roles\RolePost**](../Model/Roles/RolePost.md)|  |

### Return type

[**\Swagger\Client\Model\Roles\Role**](../Model/Roles/Role.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putRolesByRoleId**
> \Swagger\Client\Model\Roles\Role putRolesByRoleId($role_id, $body)

RolesByRoleId

Update a role by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Swagger\Client\Api\RolesApi();
$role_id = "role_id_example"; // string | 
$body = new \Swagger\Client\Model\Roles\RolePut(); // \Swagger\Client\Model\Roles\RolePut | 

try {
    $result = $api_instance->putRolesByRoleId($role_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RolesApi->putRolesByRoleId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **role_id** | **string**|  |
 **body** | [**\Swagger\Client\Model\Roles\RolePut**](../Model/Roles/RolePut.md)|  |

### Return type

[**\Swagger\Client\Model\Roles\Role**](../Model/Roles/Role.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

