<?php
/**
 * BulkPost
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * REST API v2 description for Multi-service Portal
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model\Reports;

use Swagger\Client\BaseModel;
/**
 * BulkPost Class Doc Comment
 *
 * @category    Class
 * @package     Swagger\Client
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class BulkPost extends BaseModel 
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'Reports\BulkPost';

    /**
     * Array of property to type mappings. Used for (de)serialization
     * @return array
     */
    public static function swaggerTypes()
    {
        return [
            'recipients' => 'string[]',
            'result_action' => '\Swagger\Client\Model\Reports\BulkPostResultAction',
            'parameters' => '\Swagger\Client\Model\Reports\BulkPostParameters',
            'schedule' => '\Swagger\Client\Model\Reports\BulkPostSchedule',
            'generation_date' => 'string'
        ];
    }


    /**
     * Array of property to format mappings. Used for (de)serialization
     * @return array
     */
    public static function swaggerFormats()
    {
        return [
            'recipients' => null,
            'result_action' => null,
            'parameters' => null,
            'schedule' => null,
            'generation_date' => null
        ];
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @return array
     */
    public static function attributeMap()
    {
        return [
            'recipients' => 'recipients',
            'result_action' => 'result_action',
            'parameters' => 'parameters',
            'schedule' => 'schedule',
            'generation_date' => 'generation_date'
        ];
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @return array
     */
    public static function setters()
    {
        return [
            'recipients' => 'setRecipients',
            'result_action' => 'setResultAction',
            'parameters' => 'setParameters',
            'schedule' => 'setSchedule',
            'generation_date' => 'setGenerationDate'
        ];
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @return array
     */
    public static function getters()
    {
        return [
            'recipients' => 'getRecipients',
            'result_action' => 'getResultAction',
            'parameters' => 'getParameters',
            'schedule' => 'getSchedule',
            'generation_date' => 'getGenerationDate'
        ];
    }

    /**
     * Array of attributes to checkers functions (for deserialization of responses)
     * @return array
     */
    public static function checkers()
    {
        return [
            'recipients' => 'hasRecipients',
            'result_action' => 'hasResultAction',
            'parameters' => 'hasParameters',
            'schedule' => 'hasSchedule',
            'generation_date' => 'hasGenerationDate'
        ];
    }

    /**
     * Array of attributes to validators functions (for deserialization of responses)
     * @return array
     */
    public static function validators() {
        return [
            'recipients' => 'validateRecipients',
            'result_action' => 'validateResultAction',
            'parameters' => 'validateParameters',
            'schedule' => 'validateSchedule',
            'generation_date' => 'validateGenerationDate'
        ];
    }

    

    

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        if (!empty($this->validateRecipients())) {
            $invalid_properties[] = $this->validateRecipients();
        }
        if (!empty($this->validateResultAction())) {
            $invalid_properties[] = $this->validateResultAction();
        }
        if (!empty($this->validateParameters())) {
            $invalid_properties[] = $this->validateParameters();
        }
        if (!empty($this->validateSchedule())) {
            $invalid_properties[] = $this->validateSchedule();
        }
        if (!empty($this->validateGenerationDate())) {
            $invalid_properties[] = $this->validateGenerationDate();
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        if (!empty($this->validateRecipients())) {
            return false;
        }
        if (!empty($this->validateResultAction())) {
            return false;
        }
        if (!empty($this->validateParameters())) {
            return false;
        }
        if (!empty($this->validateSchedule())) {
            return false;
        }
        if (!empty($this->validateGenerationDate())) {
            return false;
        }
        return true;
    }


    /**
     * Gets recipients
     * @return string[]
     */
    public function getRecipients()
    {
        return $this->offsetGet('recipients');
    }

    /**
     * Checks recipients
     * @return boolean
     */
    public function hasRecipients()
    {
        return $this->offsetExists('recipients');
    }

    /**
     * Sets recipients
     * @param string[] $recipients IDs of subscribed users
     * @return $this
     */
    public function setRecipients($recipients)
    {
        $this->offsetSet('recipients', $recipients);

        return $this;
    }

    /**
     * Unset recipients
     */
    public function unsetRecipients() {
        $this->offsetUnset('recipients');
    }

    /**
     * Valid recipients
     * @return array|boolean
     */
    public function validateRecipients()
    {
        if (!$this->offsetExists('recipients')) {
            return "Property 'recipients' was not initialized.";
        }
        return false;
    }


    /**
     * Gets result_action
     * @return \Swagger\Client\Model\Reports\BulkPostResultAction
     */
    public function getResultAction()
    {
        return $this->offsetGet('result_action');
    }

    /**
     * Checks result_action
     * @return boolean
     */
    public function hasResultAction()
    {
        return $this->offsetExists('result_action');
    }

    /**
     * Sets result_action
     * @param \Swagger\Client\Model\Reports\BulkPostResultAction $result_action
     * @return $this
     */
    public function setResultAction($result_action)
    {
        $this->offsetSet('result_action', $result_action);

        return $this;
    }

    /**
     * Unset result_action
     */
    public function unsetResultAction() {
        $this->offsetUnset('result_action');
    }

    /**
     * Valid result_action
     * @return array|boolean
     */
    public function validateResultAction()
    {
        if (!$this->offsetExists('result_action')) {
            return "Property 'result_action' was not initialized.";
        }
        return false;
    }


    /**
     * Gets parameters
     * @return \Swagger\Client\Model\Reports\BulkPostParameters
     */
    public function getParameters()
    {
        return $this->offsetGet('parameters');
    }

    /**
     * Checks parameters
     * @return boolean
     */
    public function hasParameters()
    {
        return $this->offsetExists('parameters');
    }

    /**
     * Sets parameters
     * @param \Swagger\Client\Model\Reports\BulkPostParameters $parameters
     * @return $this
     */
    public function setParameters($parameters)
    {
        $this->offsetSet('parameters', $parameters);

        return $this;
    }

    /**
     * Unset parameters
     */
    public function unsetParameters() {
        $this->offsetUnset('parameters');
    }

    /**
     * Valid parameters
     * @return array|boolean
     */
    public function validateParameters()
    {
        if (!$this->offsetExists('parameters')) {
            return "Property 'parameters' was not initialized.";
        }
        return false;
    }


    /**
     * Gets schedule
     * @return \Swagger\Client\Model\Reports\BulkPostSchedule
     */
    public function getSchedule()
    {
        return $this->offsetGet('schedule');
    }

    /**
     * Checks schedule
     * @return boolean
     */
    public function hasSchedule()
    {
        return $this->offsetExists('schedule');
    }

    /**
     * Sets schedule
     * @param \Swagger\Client\Model\Reports\BulkPostSchedule $schedule
     * @return $this
     */
    public function setSchedule($schedule)
    {
        $this->offsetSet('schedule', $schedule);

        return $this;
    }

    /**
     * Unset schedule
     */
    public function unsetSchedule() {
        $this->offsetUnset('schedule');
    }

    /**
     * Valid schedule
     * @return array|boolean
     */
    public function validateSchedule()
    {
        if (!$this->offsetExists('schedule')) {
            return "Property 'schedule' was not initialized.";
        }
        return false;
    }


    /**
     * Gets generation_date
     * @return string
     */
    public function getGenerationDate()
    {
        return $this->offsetGet('generation_date');
    }

    /**
     * Checks generation_date
     * @return boolean
     */
    public function hasGenerationDate()
    {
        return $this->offsetExists('generation_date');
    }

    /**
     * Sets generation_date
     * @param string $generation_date Date when the report should be generated (only one-time reports)
     * @return $this
     */
    public function setGenerationDate($generation_date)
    {
        if (!is_null($generation_date) && (strlen($generation_date) > 10)) {
            throw new \InvalidArgumentException('invalid length for $generation_date when calling BulkPost., must be smaller than or equal to 10.');
        }
        if (!is_null($generation_date) && (strlen($generation_date) < 10)) {
            throw new \InvalidArgumentException('invalid length for $generation_date when calling BulkPost., must be bigger than or equal to 10.');
        }
        if (!is_null($generation_date) && (!preg_match("/\\d{4}-\\d{2}-\\d{2}/", $generation_date))) {
            throw new \InvalidArgumentException("invalid value for $generation_date when calling BulkPost., must conform to the pattern /\\d{4}-\\d{2}-\\d{2}/.");
        }

        $this->offsetSet('generation_date', $generation_date);

        return $this;
    }

    /**
     * Unset generation_date
     */
    public function unsetGenerationDate() {
        $this->offsetUnset('generation_date');
    }

    /**
     * Valid generation_date
     * @return array|boolean
     */
    public function validateGenerationDate()
    {
        if (!$this->offsetExists('generation_date')) {
            return false;
        }
            if ($this->offsetExists('generation_date') && strlen($this->offsetGet('generation_date')) > 10) {
                return "invalid value for 'generation_date', the character length must be smaller than or equal to 10.";
            }
            if ($this->offsetExists('generation_date') && strlen($this->offsetGet('generation_date')) < 10) {
                return "invalid value for 'generation_date', the character length must be bigger than or equal to 10.";
            }
            if ($this->offsetExists('generation_date') && !preg_match("/\\d{4}-\\d{2}-\\d{2}/", $this->offsetGet('generation_date'))) {
                return "invalid value for 'generation_date', must be conform to the pattern /\\d{4}-\\d{2}-\\d{2}/.";
            }
        return false;
    }

}


