<?php
/**
 * ReportParameters
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * REST API v2 description for Multi-service Portal
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model\Reports;

use Swagger\Client\BaseModel;
/**
 * ReportParameters Class Doc Comment
 *
 * @category    Class
 * @package     Swagger\Client
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ReportParameters extends BaseModel 
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'Reports\ReportParameters';

    /**
     * Array of property to type mappings. Used for (de)serialization
     * @return array
     */
    public static function swaggerTypes()
    {
        return [
            'tenant_id' => 'string',
            'level' => '\Swagger\Client\Model\Reports\ReportLevel',
            'formats' => '\Swagger\Client\Model\Reports\ReportItems[]',
            'kind' => '\Swagger\Client\Model\Reports\ReportKind',
            'period' => '\Swagger\Client\Model\Reports\ReportPeriod'
        ];
    }


    /**
     * Array of property to format mappings. Used for (de)serialization
     * @return array
     */
    public static function swaggerFormats()
    {
        return [
            'tenant_id' => null,
            'level' => null,
            'formats' => null,
            'kind' => null,
            'period' => null
        ];
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @return array
     */
    public static function attributeMap()
    {
        return [
            'tenant_id' => 'tenant_id',
            'level' => 'level',
            'formats' => 'formats',
            'kind' => 'kind',
            'period' => 'period'
        ];
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @return array
     */
    public static function setters()
    {
        return [
            'tenant_id' => 'setTenantId',
            'level' => 'setLevel',
            'formats' => 'setFormats',
            'kind' => 'setKind',
            'period' => 'setPeriod'
        ];
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @return array
     */
    public static function getters()
    {
        return [
            'tenant_id' => 'getTenantId',
            'level' => 'getLevel',
            'formats' => 'getFormats',
            'kind' => 'getKind',
            'period' => 'getPeriod'
        ];
    }

    /**
     * Array of attributes to checkers functions (for deserialization of responses)
     * @return array
     */
    public static function checkers()
    {
        return [
            'tenant_id' => 'hasTenantId',
            'level' => 'hasLevel',
            'formats' => 'hasFormats',
            'kind' => 'hasKind',
            'period' => 'hasPeriod'
        ];
    }

    /**
     * Array of attributes to validators functions (for deserialization of responses)
     * @return array
     */
    public static function validators() {
        return [
            'tenant_id' => 'validateTenantId',
            'level' => 'validateLevel',
            'formats' => 'validateFormats',
            'kind' => 'validateKind',
            'period' => 'validatePeriod'
        ];
    }

    

    

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        if (!empty($this->validateTenantId())) {
            $invalid_properties[] = $this->validateTenantId();
        }
        if (!empty($this->validateLevel())) {
            $invalid_properties[] = $this->validateLevel();
        }
        if (!empty($this->validateFormats())) {
            $invalid_properties[] = $this->validateFormats();
        }
        if (!empty($this->validateKind())) {
            $invalid_properties[] = $this->validateKind();
        }
        if (!empty($this->validatePeriod())) {
            $invalid_properties[] = $this->validatePeriod();
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        if (!empty($this->validateTenantId())) {
            return false;
        }
        if (!empty($this->validateLevel())) {
            return false;
        }
        if (!empty($this->validateFormats())) {
            return false;
        }
        if (!empty($this->validateKind())) {
            return false;
        }
        if (!empty($this->validatePeriod())) {
            return false;
        }
        return true;
    }


    /**
     * Gets tenant_id
     * @return string
     */
    public function getTenantId()
    {
        return $this->offsetGet('tenant_id');
    }

    /**
     * Checks tenant_id
     * @return boolean
     */
    public function hasTenantId()
    {
        return $this->offsetExists('tenant_id');
    }

    /**
     * Sets tenant_id
     * @param string $tenant_id ID of the tenant that will be the subject of this report
     * @return $this
     */
    public function setTenantId($tenant_id)
    {
        if ((strlen($tenant_id) > 36)) {
            throw new \InvalidArgumentException('invalid length for $tenant_id when calling ReportParameters., must be smaller than or equal to 36.');
        }
        if ((strlen($tenant_id) < 36)) {
            throw new \InvalidArgumentException('invalid length for $tenant_id when calling ReportParameters., must be bigger than or equal to 36.');
        }
        if ((!preg_match("/[0-9a-f]{8}-([0-9a-f]{4}-){3}[0-9a-f]{12}/", $tenant_id))) {
            throw new \InvalidArgumentException("invalid value for $tenant_id when calling ReportParameters., must conform to the pattern /[0-9a-f]{8}-([0-9a-f]{4}-){3}[0-9a-f]{12}/.");
        }

        $this->offsetSet('tenant_id', $tenant_id);

        return $this;
    }

    /**
     * Unset tenant_id
     */
    public function unsetTenantId() {
        $this->offsetUnset('tenant_id');
    }

    /**
     * Valid tenant_id
     * @return array|boolean
     */
    public function validateTenantId()
    {
        if (!$this->offsetExists('tenant_id')) {
            return "Property 'tenant_id' was not initialized.";
        }
            if ($this->offsetExists('tenant_id') && strlen($this->offsetGet('tenant_id')) > 36) {
                return "invalid value for 'tenant_id', the character length must be smaller than or equal to 36.";
            }
            if ($this->offsetExists('tenant_id') && strlen($this->offsetGet('tenant_id')) < 36) {
                return "invalid value for 'tenant_id', the character length must be bigger than or equal to 36.";
            }
            if ($this->offsetExists('tenant_id') && !preg_match("/[0-9a-f]{8}-([0-9a-f]{4}-){3}[0-9a-f]{12}/", $this->offsetGet('tenant_id'))) {
                return "invalid value for 'tenant_id', must be conform to the pattern /[0-9a-f]{8}-([0-9a-f]{4}-){3}[0-9a-f]{12}/.";
            }
        return false;
    }


    /**
     * Gets level
     * @return \Swagger\Client\Model\Reports\ReportLevel
     */
    public function getLevel()
    {
        return $this->offsetGet('level');
    }

    /**
     * Checks level
     * @return boolean
     */
    public function hasLevel()
    {
        return $this->offsetExists('level');
    }

    /**
     * Sets level
     * @param \Swagger\Client\Model\Reports\ReportLevel $level
     * @return $this
     */
    public function setLevel($level)
    {
        $this->offsetSet('level', $level);

        return $this;
    }

    /**
     * Unset level
     */
    public function unsetLevel() {
        $this->offsetUnset('level');
    }

    /**
     * Valid level
     * @return array|boolean
     */
    public function validateLevel()
    {
        if (!$this->offsetExists('level')) {
            return "Property 'level' was not initialized.";
        }
        return false;
    }


    /**
     * Gets formats
     * @return \Swagger\Client\Model\Reports\ReportItems[]
     */
    public function getFormats()
    {
        return $this->offsetGet('formats');
    }

    /**
     * Checks formats
     * @return boolean
     */
    public function hasFormats()
    {
        return $this->offsetExists('formats');
    }

    /**
     * Sets formats
     * @param \Swagger\Client\Model\Reports\ReportItems[] $formats Report formats
     * @return $this
     */
    public function setFormats($formats)
    {
        $this->offsetSet('formats', $formats);

        return $this;
    }

    /**
     * Unset formats
     */
    public function unsetFormats() {
        $this->offsetUnset('formats');
    }

    /**
     * Valid formats
     * @return array|boolean
     */
    public function validateFormats()
    {
        if (!$this->offsetExists('formats')) {
            return "Property 'formats' was not initialized.";
        }
        return false;
    }


    /**
     * Gets kind
     * @return \Swagger\Client\Model\Reports\ReportKind
     */
    public function getKind()
    {
        return $this->offsetGet('kind');
    }

    /**
     * Checks kind
     * @return boolean
     */
    public function hasKind()
    {
        return $this->offsetExists('kind');
    }

    /**
     * Sets kind
     * @param \Swagger\Client\Model\Reports\ReportKind $kind
     * @return $this
     */
    public function setKind($kind)
    {
        $this->offsetSet('kind', $kind);

        return $this;
    }

    /**
     * Unset kind
     */
    public function unsetKind() {
        $this->offsetUnset('kind');
    }

    /**
     * Valid kind
     * @return array|boolean
     */
    public function validateKind()
    {
        if (!$this->offsetExists('kind')) {
            return "Property 'kind' was not initialized.";
        }
        return false;
    }


    /**
     * Gets period
     * @return \Swagger\Client\Model\Reports\ReportPeriod
     */
    public function getPeriod()
    {
        return $this->offsetGet('period');
    }

    /**
     * Checks period
     * @return boolean
     */
    public function hasPeriod()
    {
        return $this->offsetExists('period');
    }

    /**
     * Sets period
     * @param \Swagger\Client\Model\Reports\ReportPeriod $period
     * @return $this
     */
    public function setPeriod($period)
    {
        $this->offsetSet('period', $period);

        return $this;
    }

    /**
     * Unset period
     */
    public function unsetPeriod() {
        $this->offsetUnset('period');
    }

    /**
     * Valid period
     * @return array|boolean
     */
    public function validatePeriod()
    {
        if (!$this->offsetExists('period')) {
            return "Property 'period' was not initialized.";
        }
        return false;
    }

}


